'use strict';

var OrcamentoController = angular.module('OrcamentoController', []);

OrcamentoController.controller('OrcamentoCtrl', ['$scope', '$routeParams', '$rootScope', '$filter', 'Construcao', 'Material', 'MsgBox', 'CacheApp','UploadApp',
  ($scope, $routeParams, $rootScope, $filter, Construcao, Material, MsgBox, CacheApp, UploadApp) => {

    $scope.getEtapasConstrucao = () => {
        $scope.orcamento = undefined;
        Construcao.getEtapasConstrucao($scope.construcao.Id,
            (data) => {
                $scope.orcamento = [];
                var listaOrd = [];

                data.Instance.forEach(etapa => {

                    if (etapa.ObraBDIEncargos > 0) {
                        $scope.construcao.ValorOrcado = etapa.ObraOrcado;
                        $scope.construcao.ValorBDI = etapa.ObraBDI;
                        $scope.construcao.ValorEncargos = etapa.ObraEncargos;
                        $scope.construcao.ValorBDIEncargos = etapa.ObraBDIEncargos;
                    }

                    $scope.orcamento.push({
                        IdCount: etapa.Id,
                        IdConstrucao: $scope.construcao.Id,
                        Id: etapa.Id,
                        IdEtapa: etapa.Id,
                        Ordem: etapa.Ordem,
                        Descricao: etapa.Descricao,
                        Valor: etapa.ValorOrcado,
                        ValorBDIEncargos: etapa.ValorBDIEncargos,
                        ValorBDI: etapa.ValorBDI,
                        ValorEncargos: etapa.ValorEncargos,
                        SomaItem: etapa.SomaItem,
                        Nivel: etapa.Nivel,
                        Novo: false,
                        show: (etapa.Nivel == 1), //|| (listaOrd.indexOf(etapa.Ordem) < 0),
                        showSubItem: false,
                        open: false,
                        Itens: [],
                        isEtapa: true,
                        HtmlListaComposicao: $scope.getHtmlListaComposicao()
                    });

                    listaOrd.push(etapa.Ordem);

                });

            }
        );
    }

    $scope.detalheEtapa = (etapa, callBackFunction) => {
        etapa.open = !etapa.open;
        if (!etapa.consultado && etapa.Itens.length == 0)
            $scope.getCustoDetalhadoEtapaConstrucao(etapa, () => {
                if (callBackFunction != null)
                    callBackFunction();
            });

        etapa.consultado = true;
        etapa.showSubItem = !etapa.showSubItem;
    }

    $scope.adicionarEtapa = () => {
        var etapa = {
            IdCount: $scope.orcamento.length + 1,
            IdConstrucao: $scope.construcao.Id,
            Id: 0,
            IdEtapa: 0,
            Descricao: '',
            Valor: '',
            ValorBDIEncargos: 0,
            ValorBDI: 0,
            ValorEncargos: 0,
            Novo: true,
            show: true,
            open: false,
            Itens: [],
            isEtapa: true,
            EditarEtapa: $scope.getHtmlEditarEtapa()
        };

        if ($scope.orcamento.length == 0)
            etapa.Ordem = '1';
        else {
            var i = $scope.orcamento.length-1;
            while (0 <= i) {
                if ($scope.orcamento[i].show) {
                    etapa.Ordem = $scope.proximaOrdem($scope.orcamento[i].Ordem);
                    break;
                }
                i--;
            }
        }

        $scope.orcamento.push(etapa);
    }

    $scope.proximaOrdem = (ordem) => {
        if (ordem.indexOf('.') < 0)
            return (parseInt(ordem)+1).toString();
        else
            return ordem.substring(0, ordem.indexOf('.')+1) + $scope.proximaOrdem(ordem.substring(ordem.indexOf('.')+1));
    }

    $scope.cancelarEtapa = (item) => {
        if (item.editando)
            item.editando = !item.editando;
        else {
            if (item.IdEtapa == 0) {
                var idx = $scope.orcamento.indexOf(item);
                $scope.orcamento.splice(idx, 1);
            }

            item.Novo = !item.Novo;
        }
    }

    $scope.salvarEtapa = (item) => {
        if (item.selecionadoEtapa)
            item.Descricao = item.selecionadoEtapa.Nome;

        var params = {
            Id: item.Id,
            IdConstrucao: item.IdConstrucao,
            Ordem: item.Ordem,
            Descricao: item.Descricao
        }
        Construcao.setEtapaConstrucao(params,
            (data) => {
                $scope.getEtapasConstrucao();
            }
        );
    }

    $scope.alterarEtapa = (etapa) => {
        etapa.EditarEtapa = $scope.getHtmlEditarEtapa();
        etapa.editando = !etapa.editando;
    }

    $scope.excluirEtapa = (Item) => {
        MsgBox.Pergunta(Item.Descricao, 'Confirma exclusão da etapa?'
        , () => {
            Construcao.delEtapaConstrucao(Item,
                (data) => {
                    $scope.getEtapasConstrucao();
                });
        }
        , () => {
        });
    }

    $scope.duplicaEtapa = (item) => {
        Construcao.duplicaEtapa(item.IdConstrucao, item.Id,
            (data) => {
                $scope.getEtapasConstrucao();
            });
    }

    $scope.expandeEtapa = (item) => {
        item.open = !item.open;
        if (item.open)
            for (var i in $scope.orcamento) {
                if ($scope.orcamento[i].Ordem.indexOf(item.Ordem + '.') == 0
                    && item.IdEtapa != $scope.orcamento[i].IdEtapa) {
                    $scope.orcamento[i].show = true;
                    $scope.orcamento[i].open = !$scope.orcamento[i].SomaItem;
                    
                    if (!item.Itens) continue;

                    if (!item.consultado && item.Itens && item.Itens.length == 0)
                        $scope.getCustoDetalhadoEtapaConstrucao(item, () => {
                            item.consultado = true;
                            item.showSubItem = item.Itens && item.Itens.length > 0;
                        });
                    else if (item.Itens.length > 0)
                        item.showSubItem = true;
                }
            }
        else {
            for (var i in $scope.orcamento) {
                if ($scope.orcamento[i].Ordem.indexOf(item.Ordem + '.') == 0
                    && item.IdEtapa != $scope.orcamento[i].IdEtapa) {
                    $scope.orcamento[i].show = false;
                    $scope.orcamento[i].open = false;
                    $scope.orcamento[i].showSubItem = false;
                }
            }

            item.showSubItem = false;
        }

    }

    $scope.getCustoDetalhadoEtapaConstrucao = (etapa, callBackFunction) => {
        if (etapa.Itens.length == 0)
            etapa.Itens = undefined;
        Construcao.getCustoDetalhadoEtapaConstrucao($scope.construcao.Id, etapa.IdEtapa,
            (data) => {
                var justUpdate = etapa.Itens ? true : false;

                if (!justUpdate) {
                    etapa.Itens = [];
                    if (data.Instance.length == 0) {
                        callBackFunction();
                        return;
                    }

                    data.Instance.forEach(item => {
                        var novoItem = {
                            IdCount: item.IdCompra,
                            IdCompra: item.IdCompra,
                            IdConstrucao: $scope.construcao.Id,
                            IdEtapa: etapa.Id,
                            IdMaterial: item.IdMaterial,
                            Ordem: item.Ordem,
                            Origem: item.Origem,
                            UF: item.UF,
                            Periodo: item.Periodo,
                            Codigo: item.Codigo,
                            Descricao: item.Material,
                            IdUnidade: item.IdUnidade,
                            UnidadeSigla: item.UnidadeSigla,
                            Quantidade: item.Planejado.Quantidade,
                            Valor: item.Planejado.Custo,
                            ValorBDIEncargos: item.Planejado.CustoBDIEncargos,
                            ValorBDI: item.Planejado.CustoBDI,
                            ValorEncargos: item.Planejado.CustoEncargos,
                            Novo: false,
                            show: true,
                            open: false,
                            Itens: [],
                            isEtapa: false
                        };

                        etapa.Itens.push(novoItem);
                    });
                }
                else {
                    data.Instance.forEach(item => {
                        var oldInsumo = etapa.Itens.filter(i => i.IdCompra == item.IdCompra)[0]
                        if (oldInsumo) {
                            oldInsumo.IdCount = item.IdCompra;
                            oldInsumo.IdCompra = item.IdCompra;
                            oldInsumo.IdConstrucao = $scope.construcao.Id;
                            oldInsumo.IdEtapa = etapa.Id;
                            oldInsumo.IdMaterial = item.IdMaterial;
                            oldInsumo.Ordem = item.Ordem;
                            oldInsumo.Origem = item.Origem;
                            oldInsumo.UF = item.UF;
                            oldInsumo.Periodo = item.Periodo;
                            oldInsumo.Codigo = item.Codigo;
                            oldInsumo.Descricao = item.Material;
                            oldInsumo.IdUnidade = item.IdUnidade;
                            oldInsumo.UnidadeSigla = item.UnidadeSigla;
                            oldInsumo.Quantidade = item.Planejado.Quantidade;
                            oldInsumo.Valor = item.Planejado.Custo;
                            oldInsumo.ValorBDIEncargos = item.Planejado.CustoBDIEncargos;
                            oldInsumo.ValorBDI = item.Planejado.CustoBDI;
                            oldInsumo.ValorEncargos = item.Planejado.CustoEncargos;
                        }
                        else {
                            var novoItem = {
                                IdCount: item.IdCompra,
                                IdCompra: item.IdCompra,
                                IdConstrucao: $scope.construcao.Id,
                                IdEtapa: etapa.Id,
                                IdMaterial: item.IdMaterial,
                                Ordem: item.Ordem,
                                Origem: item.Origem,
                                UF: item.UF,
                                Periodo: item.Periodo,
                                Codigo: item.Codigo,
                                Descricao: item.Material,
                                IdUnidade: item.IdUnidade,
                                UnidadeSigla: item.UnidadeSigla,
                                Quantidade: item.Planejado.Quantidade,
                                Valor: item.Planejado.Custo,
                                ValorBDIEncargos: item.Planejado.CustoBDIEncargos,
                                ValorBDI: item.Planejado.CustoBDI,
                                ValorEncargos: item.Planejado.CustoEncargos,
                                Novo: false,
                                show: true,
                                open: false,
                                Itens: [],
                                isEtapa: false
                            };

                            etapa.Itens.push(novoItem);
                        }
                    });
                }

                CacheApp.setConstrucao($scope.construcao);
                
                if (callBackFunction)
                    callBackFunction();

            });

    }

    $scope.AtualizaValorObraEtapa = () => {
        Construcao.getEtapasConstrucao($scope.construcao.Id,
            (data) => {
                data.Instance.forEach( etapa => {
                    if (etapa.ObraBDIEncargos > 0) {
                        $scope.construcao.ValorOrcado = etapa.ObraOrcado;
                        $scope.construcao.ValorBDI = etapa.ObraBDI;
                        $scope.construcao.ValorEncargos = etapa.ObraEncargos;
                        $scope.construcao.ValorBDIEncargos = etapa.ObraBDIEncargos;
                    }
                    var et = $scope.orcamento.filter(o => o.IdEtapa == etapa.Id)[0];
                    et.Valor = etapa.ValorOrcado;
                    et.ValorBDIEncargos = etapa.ValorBDIEncargos;
                    et.ValorBDI = etapa.ValorBDI;
                    et.ValorEncargos = etapa.ValorEncargos;
                });
                CacheApp.setConstrucao($scope.construcao);

            }
        );
    }

    /* EDITAR ETAPA */
    $scope.etapasDefault = [
        {Id: 1, Nome: 'ESTUDO DE VIABILIDADE'},
        {Id: 2, Nome: 'PROJETO DE ARQUITETURA'},
        {Id: 3, Nome: 'PROJETOS COMPLEMENTARES'},
        {Id: 4, Nome: 'LEGALIZAÇÃO DE OBRA'},
        {Id: 5, Nome: 'MOBILIZAÇÃO E DESMOBILIZAÇÃO'},
        {Id: 6, Nome: 'SERVIÇOS PRELIMINARES'},
        {Id: 7, Nome: 'INSTALAÇÃO DO CANTEIRO DE OBRA'},
        {Id: 8, Nome: 'ABRIGO DO GERADOR'},
        {Id: 9, Nome: 'ABRIGO DE RESÍDUOS'},
        {Id: 10, Nome: 'DEMOLIÇOES E REMOÇOES'},
        {Id: 11, Nome: 'FUNDAÇÕES OU INFRA-ESTRUTURA'},
        {Id: 12, Nome: 'ESTRUTURA OU SUPERESTRUTURA'},
        {Id: 13, Nome: 'PAREDES E VEDAÇÕES'},
        {Id: 14, Nome: 'ALVENARIAS E REVESTIMENTOS'},
        {Id: 15, Nome: 'TELHADOS E FORROS'},
        {Id: 16, Nome: 'INSTALAÇÕES HIDROSSANITÁRIAS'},
        {Id: 17, Nome: 'INSTALAÇÕES ELÉTRICAS'},
        {Id: 18, Nome: 'INSTALAÇÕES DE COMBATE A INCÊNDIO'},
        {Id: 19, Nome: 'INSTALAÇÕES DE REFRIGERAÇÃO'},
        {Id: 20, Nome: 'INSTALAÇÕES DE AR CONDICIONADO'},
        {Id: 21, Nome: 'INSTALAÇÕES DE GÁS'},
        {Id: 22, Nome: 'INSTALAÇÕES PROVISÓRIAS'},
        {Id: 23, Nome: 'INSTALAÇÕES COMPLEMENTARES'},
        {Id: 24, Nome: 'ACABAMENTOS E REVESTIMENTOS'},
        {Id: 25, Nome: 'ESQUADRIAS (PORTAS E JANELAS)'},
        {Id: 26, Nome: 'ESQUADRIAS DE MADEIRA'},
        {Id: 27, Nome: 'ESQUADRIAS METÁLICAS'},
        {Id: 28, Nome: 'REVESTIMENTO DE PAREDES INTERNAS'},
        {Id: 29, Nome: 'REVESTIMENTO DE PAREDES EXTERNAS'},
        {Id: 30, Nome: 'REVESTIMENTO DE FORRO'},
        {Id: 31, Nome: 'PINTURAS E TEXTURAS'},
        {Id: 32, Nome: 'PINTURA EM PAREDES INTERNAS'},
        {Id: 33, Nome: 'PINTURA EM PAREDES EXTERNAS'},
        {Id: 34, Nome: 'LOUÇAS E METAIS'},
        {Id: 35, Nome: 'ÁREAS EXTERNAS E PAISAGISMO'},
        {Id: 36, Nome: 'LIMPEZA FINAL'},
    ];

    /* override getLista(texto)  */
    $scope.getListaEtapa = (texto, item) => {
        item.Descricao = texto;
        item.selecionadoEtapa = false;
        $scope.listaEtapa = texto.trim().length == 0 ? $scope.etapasDefault : $filter('filter')($scope.etapasDefault, {Nome: texto});
    }

    /* override clickAdd()  */
    $scope.novoEtapa = () => {
        //CacheApp.setParaCadastro();
        //$location.path('/materiais');
    }

    /* override setSelecionado(selecionado)  */
    $scope.setSelecionadoEtapa = (selecionado, item) => {
        item.selecionadoEtapa = selecionado;
    }

    $scope.mascaraOrdem = (item) => {
        if (!item.Ordem) return;
        var carac = item.Ordem.substring(item.Ordem.length-1);
        var nums = ['0','1','2','3','4','5','6','7','8','9'];
        item.Ordem = carac != '.' ? 
                        (nums.indexOf(carac) == -1 ? 
                            item.Ordem.substring(0,item.Ordem.length-1) 
                            : item.Ordem
                        ) 
                        : item.Ordem;
    }

    $scope.getHtmlEditarEtapa = () => {
        return '' +
            `<form class="form col-lg-12 col-md-12 col-sm-12 col-xs-12 center-block" name="formEtapa">` +
            `    <div class="form-group">` +
            `       <div class="row">` +
            '            <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12">' +
            '                <label>Ordem</label>' +
            `                <input type="text" class="form-control" placeholder="Ordem" ng-model="item.Ordem" ng-keyup="mascaraOrdem(item)" required>` +
            '            </div>' +
            '           <div class="col-lg-6 col-md-6 col-sm-6 col-xs-12">' +
            '                <label>Etapa</label>' +
            '                <dropdowncomplete' +
            '                    ddc-placeholder="\'Digite a Etapa\'"' +
            '                    ddc-mensagemvazio="\'NENHUMA ETAPA ENCONTRADA\'"' +
            '                    ddc-loadonfocus="true"' +
            '                    ddc-showcodigo="false"' +
            '                    ddc-showvalor="false"' +
            '                    ddc-hideadd="true"' +
            '                    ddc-construcao="construcao"' +
            '                    ddc-item="item"' +
            '                    ddc-lista="listaEtapa"' +
            '                    set-selecionado="setSelecionadoEtapa(selecionado,item)"' +
            '                    get-lista="getListaEtapa(texto, item)"' +
            '                    click-add="novoEtapa()">' +
            '                </dropdowncomplete>' +
            '           </div>' +
            '           <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12">' +
            '	            <itemsalvar ng-click="(!formEtapa.$invalid && salvarEtapa(item)); $event.stopPropagation();"></itemsalvar>' +
            '	            <itemcancelar ng-click="cancelarEtapa(item); $event.stopPropagation();"></itemcancelar>' +
            '           </div>' +
            '       </div>' +
            '    </div>' +
            '</form>';
    }
    /* FIM EDITAR ETAPA */

    /* EDITAR COMPOSIÇÃO */

    $scope.adicionarComposicao = (etapa) => {
        var item = {
            IdCount: $scope.orcamento.length + 1,
            IdCompra: 0,
            IdConstrucao: $scope.construcao.Id,
            IdEtapa: etapa.Id,
            IdMaterial: 0,
            Descricao: '',
            UnidadeSigla: '',
            Quantidade: 0,
            Valor: '',
            ValorBDIEncargos: 0,
            ValorBDI: 0,
            ValorEncargos: 0,
            Novo: true,
            show: true,
            open: false,
            Itens: [],
            isEtapa: false,
            EditarComposicao: $scope.getHtmlEditarComposicao()
        };

        if (!etapa.open)
            $scope.detalheEtapa(etapa, () => {
                if (!etapa.Itens) etapa.Itens = [];
                item.Ordem = etapa.Itens.length == 0 ? (etapa.Ordem + '.1') : $scope.proximaOrdem(etapa.Itens[etapa.Itens.length-1].Ordem);
                etapa.Itens.unshift(item);
            });
        else {
            item.Ordem = etapa.Itens.length == 0 ? (etapa.Ordem + '.1') : $scope.proximaOrdem(etapa.Itens[etapa.Itens.length-1].Ordem);
            etapa.Itens.unshift(item);
        }

    }

    $scope.alterarComposicao = (item) => {

        item.UnidadeMedida = { Id: item.IdUnidade, Sigla: item.UnidadeSigla }

        item.editando = !item.editando;
        item.Selecionado = true;
        item.IdOrigem = 0;
    }

    $scope.cancelarComposicao = (etapa, item) => {
        if (item.editando)
            item.editando = !item.editando;
        else {
            if (item.Novo) {
                var idx = etapa.Itens.indexOf(item);
                etapa.Itens.splice(idx, 1);
            }
            item.Novo = !item.Novo;
        }
    }

    $scope.salvarComposicao = (etapa, composicao) => {

        if (composicao.Novo)
            for (var i=1;i<etapa.Itens.length-1;i++)
                if (etapa.Itens[i].IdMaterial == composicao.IdMaterial) {
                    MsgBox.Atencao("Atenção!", "Composição já anexada à etapa, favor atualizar o quantitativo.", () => { });
                    return;
                }

        if (!composicao.Valor && composicao.Valor == undefined) {
            return;
        }

        if (composicao.Selecionado) {
            composicao.Novo = false;
            composicao.editando = false;
            composicao.open = false;

            if (composicao.IdCompra == 0) {
                etapa.Itens.splice(0,1)
                etapa.Itens.push(composicao);
            } 
            else
                composicao.Origem = undefined;


            $scope.salvarComposicaoSelecionado(etapa,composicao);
            return;
        }

        if (!composicao.IdUnidade) {
            return;
        }
        if (!composicao.Quantidade && composicao.Quantidade == undefined) {
            return;
        }

        composicao.Novo = false;
        composicao.editando = false;
        composicao.open = false;

        if (composicao.IdCompra == 0) {
            etapa.Itens.splice(0,1)
            etapa.Itens.push(composicao);
        }
        else
            composicao.Origem = undefined;

        var insumoCompNovo = {
            Id: 0,
            IdConstrucao: $scope.construcao.Id,
            IdEtapa: etapa.IdEtapa,
            Ordem: composicao.Ordem,
            Tipo: composicao.TipoMaterial.Id,
            Codigo: composicao.Codigo,
            Nome: composicao.Descricao,
            Valor: composicao.Valor.toString(),
            Quantidade: composicao.Quantidade
        }

        for (var i in $scope.listaUnidade)
            if ($scope.listaUnidade[i].Sigla == composicao.IdUnidade) {
                insumoCompNovo.IdUnidade = $scope.listaUnidade[i].Id;
                break;
            }

        Material.setMaterialComposicao(insumoCompNovo, 
            (data) => {
                composicao.Id = data.Instance.IdMaterial;
                composicao.IdCompra = data.Instance.IdCompra;
                composicao.IdCount = data.Instance.IdCompra;

                $scope.AtualizaValorObraEtapa();
                $scope.getCustoDetalhadoEtapaConstrucao(
                    etapa, ()=>{
                        $scope.getComposicoes( () => {
                            for (var i in etapa.Itens)
                                if (etapa.Itens[i].IdMaterial == data.Instance.IdMaterial) {
                                    $scope.getComposicaoUpdate(etapa, etapa.Itens[i]);
                                    break;
                                }
                            }
                        );
                    }
                );
            }
        );
    }

    $scope.salvarComposicaoSelecionado = (etapa, item) => {
        var materiais = [];

        var comp = {
            IdCompra: item.IdCompra ? item.IdCompra : 0,
            IdConstrucao: etapa.IdConstrucao,
            IdEtapa: etapa.IdEtapa,
            Ordem: item.Ordem,
            IdMaterial: item.IdMaterial,
            Quantidade: item.Quantidade,
            Valor: item.Valor,
            IdObraOrigem: item.IdObraOrigem ? item.IdObraOrigem : undefined
        };
        if (comp.IdCompra != 0) {
            comp.IdUnidade = item.UnidadeMedida.Id;
            comp.Descricao = item.Descricao;
        }
        materiais.push(comp);

        item.editando = false;
        if (item.IdBaseOrigem == 0 || comp.IdCompra != 0) {
            Material.setMateriaisOrcamento(JSON.stringify(materiais),
                (data) => {
                    item.IdCompra = data.Instance.IdCompra;
                    item.Id = data.Instance.IdMaterial;

                    $scope.AtualizaValorObraEtapa();
                    $scope.getCustoDetalhadoEtapaConstrucao(etapa, ()=>{
                        $scope.getComposicoes( () => {
                            for (var i in etapa.Itens)
                                if (etapa.Itens[i].IdMaterial == item.IdMaterial) {
                                    $scope.getComposicaoUpdate(etapa, etapa.Itens[i]);
                                    break;
                                }
                        });
                    });
                });
        }
        else {

            var base = {};
            for(var i in $scope.listaComposicaoDisponivel)
                if ($scope.listaComposicaoDisponivel[i].Id == item.IdOrigem) {
                        base = $scope.listaComposicaoDisponivel[i];
                        break;
                }

            materiais[0].Ordem = item.Ordem;
            materiais[0].UF = base.UF;
            materiais[0].Periodo = base.Periodo;
            Material.setComposicaoPublicaOrcamento(JSON.stringify(materiais),
                (data) => {
                    item.IdCompra = data.Instance.IdCompra;
                    item.Id = data.Instance.IdMaterial;

                    $scope.AtualizaValorObraEtapa();
                    $scope.getCustoDetalhadoEtapaConstrucao(etapa, () => {
                        $scope.getComposicoes(() => {
                            for (var i in etapa.Itens)
                                if (etapa.Itens[i].IdMaterial == item.IdMaterial) {
                                    $scope.getComposicaoUpdate(etapa, etapa.Itens[i]);
                                    break;
                                }
                        });
                    });
                });
        }

    }

    $scope.excluirComposicao = (etapa, item) => {
        MsgBox.Pergunta(item.Descricao, 'A composição será excluída do orçamento, de medições e de vínculos financeiros. Confirma?'
            , () => {
                var idx = etapa.Itens.findIndex(i => i.IdCompra == item.IdCompra);
                etapa.Itens.splice(idx, 1);

                Material.delMaterialOrcamento(item.IdCompra,
                    (data) => {
                        $scope.AtualizaValorObraEtapa();
                        $scope.getCustoDetalhadoEtapaConstrucao(etapa, () => {
                            $scope.getComposicoes(() => {});
                        });
                    }
                );
            }
            , () => {
            });
    }

    $scope.duplicaComposicao = (etapa, item) => {
        Construcao.duplicaComposicao(item.IdConstrucao, item.IdMaterial, item.IdEtapa, item.Ordem,
            (data) => {
                $scope.AtualizaValorObraEtapa();
                $scope.getCustoDetalhadoEtapaConstrucao(etapa, () => {
                    $scope.getComposicoes(()=>{});
                });
            });
    }

    /* override getLista(texto)  */
    $scope.getListaComposicao = (texto, item) => {
        $scope.listaComposicao = [];
        item.Selecionado = false;
        if (item.IdBaseOrigem == '0') {
            var params = {
                IdClienteAdmin: $scope.sessao.ContaAdmin ? $scope.sessao.IdClienteAdmin : undefined,
                IdConstrucao: item.IdOrigem,
                Nome: texto
            }
            Material.getComposicoesProprias(params,
                (result) => {
                    $scope.listaComposicao = result.Instance;
                    $scope.listaComposicao.sort(
                        (a, b) => {
                            return a.IdConstrucao == item.IdConstrucao ? -1 : (a.IdConstrucao > b.IdConstrucao ? 0 : 1)
                        }
                    );
                });
        }
        else {
            var base = {};
            for(var i in $scope.listaComposicaoDisponivel)
                if ($scope.listaComposicaoDisponivel[i].Id == item.IdOrigem) {
                    base = $scope.listaComposicaoDisponivel[i];
                    break;
                }
            Material.getComposicaoPublica(base.Origem, base.UF, base.Periodo, texto, '',
                (data) => {
                    for (var i in data.Instance) {
                        var comp = data.Instance[i];
                        var item = {};
                        item.Id = comp.Id;
                        item.Codigo = comp.Codigo;
                        item.Descricao = comp.Descricao;
                        item.Unidade = comp.Unidade;
                        item.Custo = comp.Custo;
                        item.CustoBDI = comp.Custo;
                        item.CustoEncargos = comp.Custo;
                        item.CustoTotal = comp.Custo;

                        $scope.listaComposicao.push(item);
                    }
                });
        }
    }

    /* override clickAdd()  */
    $scope.novoComposicao = () => {
        //CacheApp.setParaCadastro();
        //$location.path('/materiais');
    }

    /* override setSelecionado(selecionado)  */
    $scope.setSelecionadoComposicao = (selecionado, item) => {
        
        item.IdMaterial = selecionado.Id ? selecionado.Id : selecionado.IdComposicao;
        item.Material = selecionado.Descricao;
        item.Codigo = selecionado.Codigo;
        item.Descricao = selecionado.Nome;
        item.UnidadeSigla = selecionado.Unidade;
        item.TipoMaterial = 4;
        item.IdObraOrigem = selecionado.IdConstrucao ? selecionado.IdConstrucao : undefined;

        item.Valor = selecionado.Custo ? selecionado.Custo : selecionado.Valor;
        item.ValorBDI = selecionado.CustoBDI ? selecionado.CustoBDI : selecionado.Valor;
        item.ValorEncargos = selecionado.CustoEncargos ? selecionado.CustoEncargos : selecionado.Valor;
        item.ValorBDIEncargos = selecionado.CustoTotal ? selecionado.CustoTotal : selecionado.Valor;

        item.Selecionado = true;
    }

    $scope.getComposicoes = (callBackFunction) => {
        Construcao.getComposicoes($scope.construcao.Id,
            (data) => {
                $scope.composicoesBasePropria = data.Instance;
                if (callBackFunction)
                    callBackFunction();
            });
    }

    $scope.getOrigemBase = () => {
        Material.getOrigemBaseComposicao(
            (data) => {
                $scope.listaOrigemDisponivel = data.Instance;
                $scope.sessao.BasePublica = ($scope.sessao.BasePublica && $scope.sessao.BasePublica.IdBaseOrigem) ? $scope.sessao.BasePublica : {IdBaseOrigem: '0', IdOrigem: '0'};
                $scope.getComposicaoDisponivel($scope.sessao.BasePublica)
            });
    }

    $scope.getComposicaoDisponivel = (item) => {
        var params = {
            Origem: item ? item.IdBaseOrigem : $scope.IdBaseOrigem,
            IdClienteAdmin: $scope.sessao.ContaAdmin ? $scope.sessao.IdClienteAdmin : undefined,
        }
        Material.getBaseComposicao(params,
            (data) => {
                $scope.listaComposicaoDisponivel = data.Instance;
                if (item)
                    if (!$scope.sessao.BasePublica || $scope.sessao.BasePublica.IdBaseOrigem != item.IdBaseOrigem) {
                        item.IdOrigem = $scope.listaComposicaoDisponivel[0].Id.toString();
                        $scope.setBaseSessao(item);
                    }
            });
    }

    $scope.getComposicao = (composicao) => {
        if (composicao.editando) return;
        composicao.open = !composicao.open;
        composicao.HtmlSubItem = composicao.open ? $scope.getHtmlListaInsumo() : null;
        composicao.HtmlSubItemMobile = composicao.open ? $scope.getHtmlListaInsumoMobile : null;
        if (composicao.open) {
            composicao.Itens = $scope.composicoesBasePropria.filter(c => c.Id == composicao.IdMaterial)[0].Itens;
            composicao.Itens.forEach(i => {
                i.Caminho = [composicao.IdMaterial];
            })
        }
    }

    $scope.getComposicaoUpdate = (etapa, composicao) => {

        function updateRecursive (lista, oldComp, newComp) {
            if (!lista || lista.length == 0)
                return true
            else {
                var oc = oldComp.Itens.filter(i => i.Id == lista[0])[0];
                var nc = newComp.Itens ? 
                    newComp.Itens.filter(i => i.Id == lista[0])[0] : 
                    $scope.composicoesBasePropria.filter(c => c.Id == lista[0])[0];

                oc.EncargoSocial = nc.EncargoSocial;
                oc.BDI = nc.BDI;
                oc.ValorUnitario = nc.ValorUnitario ? nc.ValorUnitario : nc.Custo;
                oc.CustoTotal = nc.CustoTotal;
                oc.CustoBDI = nc.CustoBDI;
                oc.CustoEncargos = nc.CustoEncargos;
                oc.Custo = nc.Custo;

                lista.splice(0,1);

                updateRecursive(lista, oc, nc);
            }
        }

        var comp = [];

        if (composicao.Caminho) {
            if (composicao.Caminho.length > 1) {
                var lista = composicao.Caminho.filter(c => c != 0);
                var oldComp = etapa.Itens.filter(c => c.IdMaterial == lista[0])[0];
                var newComp = $scope.composicoesBasePropria.filter(c => c.Id == lista[0])[0];
                lista.splice(0,1);

                updateRecursive(lista,oldComp,newComp);
                comp = $scope.composicoesBasePropria.filter(c => c.Id == composicao.Id)[0];
                composicao.Itens = comp.Itens;
            }
            else {
                var compRaiz = $scope.composicoesBasePropria.filter(c => c.Id == composicao.Caminho[0])[0];
                composicao.Itens = $scope.composicoesBasePropria.filter(c => c.Id == composicao.Id)[0].Itens;
                comp =  compRaiz.Itens.filter(c => c.Id == composicao.Id)[0];
            }

            var caminho = composicao.Caminho.filter(c => c!= 0);
            caminho.push(composicao.Id);
            composicao.Itens.forEach(c => {
                c.Caminho = caminho;
            })
        }
        else {
            comp = $scope.composicoesBasePropria.filter(c => c.Id == composicao.IdMaterial)[0];
            composicao.Itens = comp.Itens;

            composicao.Itens.forEach(c => {
                c.Caminho = [composicao.IdMaterial];
            })
        }


        composicao.EncargoSocial = comp.EncargoSocial;
        composicao.BDI = comp.BDI;
        composicao.ValorUnitario = comp.ValorUnitario ? comp.ValorUnitario : comp.Custo;
        composicao.CustoTotal = comp.CustoTotal;
        composicao.CustoBDI = comp.CustoBDI;
        composicao.CustoEncargos = comp.CustoEncargos;
        composicao.Custo = comp.Custo;

    }

    $scope.getListaUnidades = () => {
        Material.getListaUnidades(
            (data) => {
                $scope.listaUnidade = data.Instance;
                for (let i = 0; i < $scope.listaUnidade.length; i++) {
                    const TextoUnidadeView = `${$scope.listaUnidade[i].Descricao} (${$scope.listaUnidade[i].Sigla})`
                    $scope.listaUnidade[i].TextoUnidadeView = TextoUnidadeView;
                }
            }
        );
    }

    $scope.setBaseSessao = (base) => {
        $scope.sessao.BasePublica = {IdBaseOrigem: base.IdBaseOrigem, IdOrigem: base.IdOrigem};
        CacheApp.setSessao($scope.sessao);
    }

    $scope.getHtmlListaComposicao = () => {
        return `
            <div class="col-lg-12 col-md-12 col-sm-12" ng-show="item.showSubItem">
                <div class="panel panel-composicao sombreado">
                    <div class="panel-heading">
                        <div class="row">
                            <div class="notShowMobile">
                                <div class="col-md-1 col-sm-1">
                                    Ordem
                                </div>
                                <div class="col-md-1 col-sm-1 text-center">
                                    Origem
                                </div>
                                <div class="col-md-3 col-sm-3">
                                    Composição
                                </div>
                                <div class="col-md-1 col-sm-1 text-center">
                                    Unidade
                                </div>
                                <div class="col-md-2 col-sm-2 text-right">
                                    Quantidade
                                </div>
                                <div class="col-md-2 col-sm-2 text-right">
                                    Valor ({{construcao.Moeda}})
                                </div>
                                <div class="col-md-2 col-sm-2 text-right">
                                    Total ({{construcao.Moeda}})
                                </div>
                            </div>
                        </div>
                    </div>
                    <ul class="list-group">
                        <mensagemvazio
                            msg-grid="true"
                            msg-click="adicionarComposicao(item)"
                            msg-lista="item.Itens"
                            msg-texto="'Nenhum item orçado para ' + item.Descricao"
                            msg-subtexto="'e adicione composições para ' + item.Descricao"
                            msg-permissao="'SET_ORCAMENTO'"
                            msg-acessos="construcao.Acessos"></mensagemvazio>
                        <li 
                            class="list-group-item LinhaListaHand" 
                            ng-mouseover="subItem.mouseovercomp=true" 
                            ng-mouseleave="subItem.mouseovercomp=false" 
                            ng-repeat="subItem in item.Itens"
                            ng-click="!subItem.Novo && getComposicao(subItem); $event.stopPropagation();">
                            <div class="row">
                                <div ng-show="subItem.Novo">
                                    <div dynamic="subItem.EditarComposicao"></div>
                                </div>
                                <div class="notShowMobile" ng-show="!subItem.Novo && !subItem.Origem">
                                    <loadcirclesmall ng-show="!subItem.Origem"></loadcirclesmall>
                                </div>
                                <div class="notShowMobile" ng-show="!subItem.Novo && subItem.Origem">
                                    <div class="col-lg-1 col-md-1 col-sm-1">
                                        <span ng-show="!subItem.editando" ng-class="{'texto': !subItem.open, 'textoBold': subItem.open}">{{subItem.Ordem}}</span>
                                        <input ng-show="subItem.editando" type="text" class="form-control" placeholder="Ordem" ng-model="subItem.Ordem">
                                    </div>
                                    <div class="col-lg-1 col-md-1 col-sm-1 text-center">
                                        <span ng-show="subItem.Origem" ng-class="{'texto': !subItem.open, 'textoBold': subItem.open}">{{subItem.Origem}} <br /> {{subItem.Codigo}}</span>
                                    </div>
                                    <div class="col-lg-3 col-md-3 col-sm-3">
                                        <span ng-show="!subItem.editando" ng-class="{'texto': !subItem.open, 'textoBold': subItem.open}">{{subItem.Descricao}}</span>
                                        <input ng-show="subItem.editando" class="form-control" ng-model="subItem.Descricao" >
                                    </div>
                                    <div class="col-lg-1 col-md-1 col-sm-1 text-center">
                                        <span ng-show="!subItem.editando" ng-class="{'texto': !subItem.open, 'textoBold': subItem.open}">{{subItem.UnidadeSigla}}</span>
                                        <select class="form-control"
                                                ng-model="subItem.UnidadeMedida"
                                                ng-show="subItem.editando"
                                                ng-options="unidade.TextoUnidadeView for unidade in listaUnidade track by unidade.Id" required>
                                            <option style="display:none" value=""> Unidade de medida </option>
                                        </select>
                                    </div>
                                    <div class="col-lg-2 col-md-2 col-sm-2 text-right">
                                        <span ng-show="!subItem.editando" ng-class="{'texto': !subItem.open, 'textoBold': subItem.open}">
                                            <formata-numero format-valor="subItem.Quantidade" format-tipo="'quantidade'"></formata-numero>
                                        </span>
                                        <input ng-show="subItem.editando" type="text" class="form-control" placeholder="Quantidade" ng-model="subItem.Quantidade" ui-number-mask="2">
                                    </div>
                                    <div class="col-lg-4 col-md-4 col-sm-4 text-right">
                                        <div class="row">
                                            <div class="col-lg-6 col-md-6 col-sm-6">
                                                <span ng-class="{'texto': !subItem.open, 'textoBold': subItem.open}">
                                                    <informativo ng-show="comEncargos && comBDI && subItem.ValorBDIEncargos.toFixed(7).toString().substring(subItem.ValorBDIEncargos.toFixed(7).toString().indexOf('.')+3) != '00000'" icn-title="subItem.ValorBDIEncargos.toFixed(7)"></informativo>
                                                    <informativo ng-show="!comEncargos && comBDI && subItem.ValorBDI.toFixed(7).toString().substring(subItem.ValorBDI.toFixed(7).toString().indexOf('.')+3) != '00000'" icn-title="subItem.ValorBDI.toFixed(7)"></informativo>
                                                    <informativo ng-show="comEncargos && !comBDI && subItem.ValorEncargos.toFixed(7).toString().substring(subItem.ValorEncargos.toFixed(7).toString().indexOf('.')+3) != '00000'" icn-title="subItem.ValorEncargos.toFixed(7)"></informativo>
                                                    <informativo ng-show="!comEncargos && !comBDI && subItem.Valor.toFixed(7).toString().substring(subItem.Valor.toFixed(7).toString().indexOf('.')+3) != '00000'" icn-title="subItem.Valor.toFixed(7)"></informativo>
                                                    <formata-numero ng-show="comEncargos && comBDI" format-valor="subItem.ValorBDIEncargos" format-tipo="'real'"></formata-numero>
                                                    <formata-numero ng-show="!comEncargos && comBDI" format-valor="subItem.ValorBDI" format-tipo="'real'"></formata-numero>
                                                    <formata-numero ng-show="comEncargos && !comBDI" format-valor="subItem.ValorEncargos" format-tipo="'real'"></formata-numero>
                                                    <formata-numero ng-show="!comEncargos && !comBDI" format-valor="subItem.Valor" format-tipo="'real'"></formata-numero>
                                                </span>
                                            </div>
                                            <div class="col-lg-6 col-md-6 col-sm-6">
                                                <div ng-class="{'texto': !subItem.open, 'textoBold': subItem.open}">
                                                    <informativo ng-show="comEncargos && comBDI && (subItem.ValorBDIEncargos*subItem.Quantidade).toFixed(7).toString().substring((subItem.ValorBDIEncargos*subItem.Quantidade).toFixed(7).toString().indexOf('.')+3) != '00000'" icn-title="(subItem.ValorBDIEncargos*subItem.Quantidade).toFixed(7)"></informativo>
                                                    <informativo ng-show="!comEncargos && comBDI && (subItem.ValorBDI*subItem.Quantidade).toFixed(7).toString().substring((subItem.ValorBDI*subItem.Quantidade).toFixed(7).toString().indexOf('.')+3) != '00000'" icn-title="(subItem.ValorBDI*subItem.Quantidade).toFixed(7)"></informativo>
                                                    <informativo ng-show="comEncargos && !comBDI && (subItem.ValorEncargos*subItem.Quantidade).toFixed(7).toString().substring((subItem.ValorEncargos*subItem.Quantidade).toFixed(7).toString().indexOf('.')+3) != '00000'" icn-title="(subItem.ValorEncargos*subItem.Quantidade).toFixed(7)"></informativo>
                                                    <informativo ng-show="!comEncargos && !comBDI && (subItem.Valor*subItem.Quantidade).toFixed(7).toString().substring((subItem.Valor*subItem.Quantidade).toFixed(7).toString().indexOf('.')+3) != '00000'" icn-title="(subItem.Valor*subItem.Quantidade).toFixed(7)"></informativo>
                                                    <formata-numero ng-show="comEncargos && comBDI" format-valor="subItem.ValorBDIEncargos*subItem.Quantidade" format-tipo="'real'"></formata-numero>
                                                    <formata-numero ng-show="!comEncargos && comBDI" format-valor="subItem.ValorBDI*subItem.Quantidade" format-tipo="'real'"></formata-numero>
                                                    <formata-numero ng-show="comEncargos && !comBDI" format-valor="subItem.ValorEncargos*subItem.Quantidade" format-tipo="'real'"></formata-numero>
                                                    <formata-numero ng-show="!comEncargos && !comBDI" format-valor="subItem.Valor*subItem.Quantidade" format-tipo="'real'"></formata-numero>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="row">
                                            <div class="col-lg-12 col-md-12 col-sm-12">
                                                <div ng-show="(!subItem.editando && !subItem.Novo && subItem.mouseovercomp) || subItem.open"><br>
                                                    <itemaddsub ng-show="subItem.open" ng-click="adicionarInsumo(subItem); $event.stopPropagation();" btn-permissao="'SET_ORCAMENTO'" btn-acessos="construcao.Acessos"></itemaddsub>
                                                    <itemduplicar ng-show="!subItem.open" ng-click="duplicaComposicao(item, subItem); $event.stopPropagation();" btn-permissao="'SET_ORCAMENTO'" btn-acessos="construcao.Acessos"></itemduplicar>
                                                    <itemeditar ng-show="!subItem.open" ng-click="alterarComposicao(subItem); $event.stopPropagation();" btn-permissao="'SET_ORCAMENTO'" btn-acessos="construcao.Acessos"></itemeditar>
                                                    <itemexcluir ng-show="!subItem.open" ng-click="excluirComposicao(item, subItem); $event.stopPropagation();" btn-permissao="'DEL_ORCAMENTO'" btn-acessos="construcao.Acessos"></itemexcluir>
                                                    <itemabrir ng-show="!subItem.open" ng-click="!subItem.Novo && getComposicao(subItem); $event.stopPropagation();"></itemabrir>
                                                    <itemfechar ng-show="subItem.open" ng-click="!subItem.Novo && getComposicao(subItem); $event.stopPropagation();"></itemfechar>
                                                </div>
                                                <div ng-show="subItem.editando"><br>
                                                    <itemsalvar ng-click="salvarComposicao(item, subItem); $event.stopPropagation();"></itemsalvar>
                                                    <itemcancelar ng-click="cancelarComposicao(item, subItem); $event.stopPropagation();"></itemcancelar>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div ng-click="$event.stopPropagation();">
                                <div class="notShowMobile" dynamic="subItem.HtmlSubItem"></div>
                            </div>
                        </li>
                    </ul>
                </div>
            </div>
        `
    }

    $scope.getHtmlEditarComposicao = () => {

        return '' +
            '<form role="form" class="form" name="formComposicao">' +
            '    <div class="row" ng-show="deuErro">' +
            '        <div class="form-group">' +
            '            <div class="col-lg-4 col-lg-offset-4 col-md-4 col-md-offset-4 col-sm-4 col-sm-offset-4 col-xs-12 col-xs-offset-0">' +
            '                <mensagemform />' +
            '            </div>' +
            '        </div>' +
            '    </div>' +
            '    <div class="row">' +
            '        <div class="form-group">' +
            '           <div class="col-lg-10 col-md-10 col-sm-10 col-xs-12">' +
            '               <div class="row">' +
            '               <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">' +
            '               <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '                   <label>Ordem</label>' +
            '                   <input type="text" class="form-control" placeholder="Ordem" maxlength="20" ng-model="subItem.Ordem" required>' +
            '               </div>' +
            '               <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '                   <label>Base</label>' +
            `                   <select class="form-control" ng-model="subItem.IdBaseOrigem" ng-init="subItem.IdBaseOrigem = sessao.BasePublica ? sessao.BasePublica.IdBaseOrigem : '0'" ng-change="getComposicaoDisponivel(subItem)">` +
            '                       <option ng-repeat="base in listaOrigemDisponivel" value="{{base.Id}}">{{base.Nome}}</option>' +
            '                   </select>' +
            '               </div>' +
            '               <div class="col-lg-7 col-md-7 col-sm-7 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            `                   <label>{{subItem.IdBaseOrigem == 0 ? 'Obras' : 'Período'}}</label>` +
            `                   <select class="form-control" ng-model="subItem.IdOrigem"  ng-init="subItem.IdOrigem = sessao.BasePublica ? sessao.BasePublica.IdOrigem : '0'" ng-change="setBaseSessao(subItem)">` +
            '                       <option ng-repeat="base in listaComposicaoDisponivel" value="{{base.Id}}">{{base.Descricao}}</option>' +
            '                   </select>' +
            '               </div>' +
            '               <div class="row col-lg-12 col-md-12 col-sm-12 col-xs-12">&nbsp;</div>' +
            '               <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '                   <label>Composição</label>' +
            '                   <dropdowncomplete' +
            '                           ddc-placeholder="\'Digite a Composição\'"' +
            '                           ddc-mensagemvazio="\'NENHUMA COMPOSIÇÃO ENCONTRADA\'"' +
            '                           ddc-showcodigo="true"' +
            '                           ddc-showvalor="true"' +
            '                           ddc-hideadd="true"' +
            '                           ddc-construcao="construcao"' +
            '                           ddc-item="subItem"' +
            '                           ddc-lista="listaComposicao"' +
            '                           set-selecionado="setSelecionadoComposicao(selecionado,subItem)"' +
            '                           get-lista="getListaComposicao(texto,subItem)"' +
            '                           click-add="novoComposicao()">' +
            '                   </dropdowncomplete>' +
            '               </div>' +
            '               </div>' +
            '               </div>' +
            '               <div class="row col-lg-12 col-md-12 col-sm-12 col-xs-12">&nbsp;</div>' +
            '               <div ng-show="subItem.Selecionado">' +
            '                   <div class="col-lg-4 col-md-4 col-sm-4 col-xs-12">' +
            '                       <div class="showMobile"><br /></div>' +
            '                       <label>Consumo {{!subItem.UnidadeSigla ? "" : ("("+subItem.UnidadeSigla+")")}}</label>' +
            '                       <input type="text" class="form-control" placeholder="Quantidade" ng-model="subItem.Quantidade" ng-disabled="!subItem.UnidadeSigla" ui-number-mask="2" required>' +
            '                   </div>' +
            '                   <div class="col-lg-4 col-md-4 col-sm-4 col-xs-12">' +
            '                       <label>Custo</label>' +
            '                       <div class="text-left panel-fonticon">' +
            '                           <formata-numero ng-show="comEncargos && comBDI" format-valor="subItem.ValorBDIEncargos" format-tipo="\'real\'"></formata-numero>' +
            '                           <formata-numero ng-show="!comEncargos && comBDI" format-valor="subItem.ValorBDI" format-tipo="\'real\'"></formata-numero>' +
            '                           <formata-numero ng-show="comEncargos && !comBDI" format-valor="subItem.ValorEncargos" format-tipo="\'real\'"></formata-numero>' +
            '                           <formata-numero ng-show="!comEncargos && !comBDI" format-valor="subItem.Valor" format-tipo="\'real\'"></formata-numero>' +
            '                       </div>' +
            '                   </div>' +
            '                   <div class="col-lg-4 col-md-4 col-sm-4 col-xs-12">' +
            '                       <label>Total</label>' +
            '                       <div class="text-left panel-fonticon">' +
            '                           <formata-numero ng-show="comEncargos && comBDI" format-valor="subItem.ValorBDIEncargos*subItem.Quantidade" format-tipo="\'real\'"></formata-numero>' +
            '                           <formata-numero ng-show="!comEncargos && comBDI" format-valor="subItem.ValorBDI*subItem.Quantidade" format-tipo="\'real\'"></formata-numero>' +
            '                           <formata-numero ng-show="comEncargos && !comBDI" format-valor="subItem.ValorEncargos*subItem.Quantidade" format-tipo="\'real\'"></formata-numero>' +
            '                           <formata-numero ng-show="!comEncargos && !comBDI" format-valor="subItem.Valor*subItem.Quantidade" format-tipo="\'real\'"></formata-numero>' +
            '                       </div>' +
            '                   </div>' +
            '               </div>' +
            '	            <div ng-show="!subItem.Selecionado">' +
            '		            <div class="col-lg-2 col-md-2 col-sm-2">' +
            '		                <label>Tipo</label>' +
            '                       <select class="form-control input"' +
            '                           ng-model="subItem.TipoMaterial"' +
            '                           ng-options="tipo.Nome for tipo in listaTipoMaterial track by tipo.Id" required>' +
            '                           <option style="display:none" value=""> Selecione o tipo </option>' +
            '                       </select>' +
            '		            </div>' +
            '                   <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12">' +
            '                       <label>Unidade</label>'+
            '	                    <select class="form-control" ng-model="subItem.IdUnidade" ng-init="subItem.IdUnidade = subItem.IdUnidade + \'\'" required>' +
            '	                        <option value="" selected disabled> Unidade </option>' +
            '	                        <option ng-repeat="unidade in listaUnidade" value="{{unidade.Sigla}}">{{unidade.Descricao}} ({{unidade.Sigla}})</option>' +
            '	                    </select>' +
            '                   </div>' +
            '                   <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12">' +
            '                       <label>Código</label>'+
            '	                    <input type="text" class="form-control" placeholder="Código" maxlength="20" ng-model="subItem.Codigo" ng-init="subItem.Codigo =  subItem.Codigo + \'\'">' +
            '                   </div>' +
            '                   <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12">' +
            '                       <label>Valor Unitário ({{construcao.Moeda}})</label>'+
            '                       <input type="text" class="form-control" placeholder="Valor Unitário" maxlength="16" ng-model="subItem.Valor" ui-number-mask="decimals" required>' +
            '                   </div>' +
            '                   <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12">' +
            '                       <label>Quantidade</label>'+
            '                       <input type="text" class="form-control" placeholder="Valor Unitário (R$)" maxlength="16" ng-model="subItem.Quantidade" ui-number-mask="decimals" required>' +
            '                   </div>' +
            '               </div>' +
            '           </div>' +
            '           <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12 text-center">' +
            '               <itemsalvar ng-click="salvarComposicao(item,subItem); $event.stopPropagation();"></itemsalvar>' +
            '               <itemcancelar ng-click="cancelarComposicao(item,subItem); $event.stopPropagation();"></itemcancelar>' +
            '           </div>' +
            '       </div>' +
            '   </div>' +
            '</form>';
    }
    /* FIM EDITAR COMPOSIÇÃO */

    /* EDITAR MATERIAL */

    $scope.adicionarInsumo = (composicao) => {
        var item = {
            IdCount: $scope.orcamento.length + 1,
            Id: 0,
            Tipo: '',
            Codigo: '',
            Unidade: '',
            Nome: '',
            Descricao: '',
            CustoUnitario: '',
            Consumo: '',
            Caminho: [composicao.IdMaterial],
            Novo: true,
            HtmlEditarInsumo: $scope.getHtmlEditarInsumo()
        };

        if (!composicao.open)
            $scope.getComposicao(composicao);

        composicao.Itens.unshift(item);
    }

    $scope.alterarInsumo = (item) => {
        $scope.getTipoMaterial();

        item.UnidadeMedida = {Id: item.IdUnidade, Sigla: item.Unidade}
        item.TipoMaterial = {Id: item.Tipo, TipoDescricao: item.TipoDescricao}

        item.Selecionado = true;
        item.editando = !item.editando;
    }

    $scope.cancelarInsumo = (composicao, item) => {
        if (item.editando)
            item.editando = !item.editando;
        else {
            if (item.Novo) {
                var idx = composicao.Itens.indexOf(item);
                composicao.Itens.splice(idx, 1);
            }

            item.Novo = !item.Novo;
        }
    }

    $scope.setMaterial = (material, callBackFunction) => {
        Material.setMaterial($scope.construcao.Id, material,
            (data) => {
                var retorno = data.Instance[0];
                if (retorno.Codigo != 0) {
                    MsgBox.Atencao(material.Nome, retorno.Mensagem, null);
                    callBackFunction(null);
                }
                else {
                    callBackFunction(retorno.IdMaterial);
                }
            });
    }

    $scope.getTipoMaterial = () => {
        Material.getTipoMaterial(
            (data) => {
                $scope.listaTipoMaterial = data.Instance;
            });
    }


    $scope.salvarInsumo = (etapa, composicao, insumo) => {

        if (insumo.Novo)
            for (var i=1; i<composicao.Itens.length; i++)
                if (composicao.Itens[i].Id == insumo.Id) {
                    MsgBox.Atencao("Atenção!", "Insumo já anexado à composição, favor atualizar o quantitativo.", () => { });
                    return;
                }

        if (!insumo.Consumo && insumo.Consumo == undefined) {
            return;
        }

        var composicaoNova = {
            Id: composicao.IdMaterial ? composicao.IdMaterial : composicao.Id,
            IdConstrucao: $scope.construcao.Id,
            Codigo: composicao.Codigo,
            Descricao: composicao.Descricao,
            Unidade: composicao.UnidadeSigla ? composicao.UnidadeSigla : composicao.Unidade,
            Ordem: composicao.Ordem ? composicao.Ordem : '',
            Itens: []
        }

        composicao.Itens.forEach(item => {
            composicaoNova.Itens.push({
                Id: item.Id,
                Consumo: item.Consumo ? item.Consumo : item.Coeficiente,
                ValorUnitario: item.CustoUnitario ? item.CustoUnitario : item.ValorUnitario
            });
        });

        if (insumo.Selecionado) {
            insumo.editando = false;

            if (insumo.Novo == true) {
                insumo.Novo = false;
                $scope.setInsumoComposicao(etapa, composicao, insumo);
                return;
            } else {
                insumo.TipoDescricao = undefined;
                //var zero = 0.0
                var idUnidadeOld = null;

                for (var i in $scope.listaUnidade) {
                    if(insumo.Unidade == $scope.listaUnidade[i].Sigla){
                        idUnidadeOld = $scope.listaUnidade[i].Id;
                    }
                }

                var insumoAtualizar = {
                    Id: insumo.Id,
                    IdComposicao: composicaoNova.Id,
                    Tipo: insumo.TipoMaterial.Id,
                    TipoDescricao: insumo.TipoMaterial.Tipo,
                    Codigo: insumo.Codigo,
                    Nome: insumo.Nome ? insumo.Nome : insumo.Descricao,
                    IdUnidade: typeof(insumo.UnidadeMedida) != 'object' ? idUnidadeOld : insumo.UnidadeMedida.Id,
                    Unidade: typeof(insumo.UnidadeMedida) != 'object' ? insumo.Unidade : insumo.UnidadeMedida.Sigla,
                    Valor: insumo.ValorUnitario ? insumo.ValorUnitario : 0, //(insumo.CustoBDI ? (insumo.CustoBDI ? insumo.CustoBDI : insumo.Custo) : 0),
                    Coeficiente: insumo.Coeficiente
                }

                $scope.setMaterial(insumoAtualizar, (IdInsumo) => {
                    $scope.AtualizaValorObraEtapa();
                    $scope.getCustoDetalhadoEtapaConstrucao(etapa, ()=>{
                        $scope.getComposicoes( () => {
                            // var compUpd = etapa.Itens.filter(item => item.IdMaterial == composicaoNova.Id)
                            // if (compUpd && compUpd.length > 0)
                            $scope.getComposicaoUpdate(etapa, composicao)
                        });
                    });
                });
                return;
            }
        }

        if (!insumo.IdUnidade) {
            return;
        }

        if ((!insumo.CustoUnitario && insumo.CustoUnitario == undefined) && (!insumo.ValorUnitario && insumo.ValorUnitario == undefined)) {
            return;
        }

        insumo.editando = false;
        insumo.Novo = false;

        var insumoNovo = {
            Id: insumo.Id,
            Tipo: insumo.Tipo ? insumo.Tipo : insumo.TipoSelecionado.Id,
            Codigo: insumo.Codigo,
            Nome: insumo.Nome ? insumo.Nome : insumo.Descricao,
            IdUnidade: insumo.IdUnidade
        }

        insumoNovo.Valor = insumo.CustoUnitario;

        $scope.setMaterial(insumoNovo, (IdInsumo) => {
            if (!IdInsumo) {
                MsgBox.Atencao("Atenção!", "Erro ao efetuar o cadastro. Tente novamente, se persistir entre em contato com relacionamento Vigha.", () => { });
                return;
            }

            if (insumo.Id == 0)
                composicaoNova.Itens.filter(i => i.Id == 0)[0].Id = IdInsumo

            insumo.editando = false;
            insumo.Tipo = insumo.TipoSelecionado.Id;
            insumo.Id = IdInsumo;

            $scope.setInsumoComposicao(etapa, composicao, insumo);
        });

    }

    $scope.setUnidadeSigla = (detail) => {
        for (var i in $scope.listaUnidade)
            if ($scope.listaUnidade[i].Id == detail.IdUnidade) {
                detail.UnidadeSigla = $scope.listaUnidade[i].Sigla;
                break;
            }
    }

    /* override getLista(texto)  */
    $scope.getListaInsumo = (texto, item) => {
        item.Selecionado = false;
        item.Nome = texto;
        var base = $scope.listaComposicaoDisponivel.filter(l => l.Id.toString() == item.IdOrigem)[0];

        if (!base)
            base = {
                Origem: 0,
                UF: '',
                Periodo: ''
            }

        if (!base.Origem) {
            base.IdConstrucao = base.Id;
            base.Origem = 0;
        }

        Material.getListaMaterial((base.IdConstrucao || base.IdConstrucao == 0) ? base.IdConstrucao : $scope.construcao.Id, base.Origem, texto, base.UF, base.Periodo,
            (data) => {
                $scope.listaInsumo = [];
                var materiais = data.Instance;
                for (var i in materiais)
                    $scope.listaInsumo.push(materiais[i]);

                if ($scope.listaInsumo.length == 0)
                    item.Selecionado = false;

                $scope.listaInsumo.sort(
                    (a, b) => {
                        return a.IdConstrucao == $scope.construcao.Id ? -1 : (a.IdConstrucao > b.IdConstrucao ? 0 : 1)
                    }
                );

            });

    }

    /* override clickAdd()  */
    $scope.novoInsumo = () => {
        //CacheApp.setParaCadastro();
        //$location.path('/materiais');
    }

    /* override setSelecionado(selecionado)  */
    $scope.setSelecionadoInsumo = (selecionado, item) => {

        item.Id = selecionado.Id;
        item.Tipo = selecionado.Tipo;
        item.Nome = selecionado.Nome;
        item.UnidadeSigla = selecionado.UnidadeSigla;
        item.CustoUnitario = selecionado.Valor;
        item.IdObraOrigem = selecionado.IdConstrucao;
        item.Descricao = selecionado.Nome;
        item.Codigo = selecionado.Codigo;
        item.Origem = selecionado.Origem;

        if (selecionado.Origem == 0) {
            if (selecionado.Importado && selecionado.Importado == 1) 
                item.Importado = true; 
            else 
                item.Importado = false;
        }
        else {
            item.IdBasePublica = selecionado.IdBasePublica;
            item.UF = selecionado.UF;
            item.Periodo = selecionado.Periodo;
        }

        item.Selecionado = true;
    }

    $scope.getHtmlListaInsumo = () => {
        return '' +
            '<br ng-show="subItem.open && !subItem.Novo" />' +
            '<div class="panel panel-insumo sombreado" ng-show="subItem.open && !subItem.Novo">' +
            '<div class="panel-heading tr-fonteTitulo">' +
            '    <div class="row">' +
            '	<div class="col-lg-6 col-md-6 col-sm-6">' +
            '	    <div class="row">' +
            '		<div class="col-lg-2 col-md-2 col-sm-2 text-center">' +
            '	        Tipo' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2 text-center">' +
            '	        Código' +
            '		</div>' +
            '		<div class="col-lg-6 col-md-6 col-sm-6 text-left">' +
            '	        Insumo' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2 text-center">' +
            '	        Unidade' +
            '		</div>' +
            '	    </div>' +
            '	</div>' +
            '	<div class="col-lg-6 col-md-6 col-sm-6 text-right">' +
            '	    <div class="row">' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		    Preço' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		    Consumo' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		    Custo' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		    <span ng-show="(construcao.EncargoSocial > 0) && comEncargos">Enc. Social</span>' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		  <span ng-show="((construcao.BDIMaoObra > 0 || construcao.BDIMaterial > 0) || (construcao.BDIMaoObra == 0 && construcao.BDIMaterial == 0 && construcao.BDI > 0)) && comBDI">BDI</span>' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		    Total' +
            '		</div>' +
            '	    </div>' +
            '	</div>' +
            '    </div>' +
            '</div>' +
            '<ul class="list-group tr-fonteItem">' +
            `    <li class="list-group-item" ng-class="{'LinhaLista': detail.Tipo != 4, 'LinhaListaHand': detail.Tipo == 4}" ng-repeat="detail in subItem.Itens" ng-mouseover="mouseoverinsumo= (true && detail.TipoDescricao)" ng-mouseleave="mouseoverinsumo=false" ng-click="(detail.Tipo == 4 && !detail.editando && getInsumoComp(detail)); $event.stopPropagation();">` +
            '	<div class="row" ng-show="!detail.Novo && !detail.TipoDescricao">' +
            '       <loadcirclesmall ng-show="!detail.TipoDescricao"></loadcirclesmall>' +
            '	</div>' +
            '	<div class="row" ng-show="!detail.Novo && detail.TipoDescricao">' +
            '	<div class="col-lg-6 col-md-6 col-sm-6">' +
            '	    <div class="row">' +
            '		<div class="col-lg-2 col-md-2 col-sm-2 text-center">' +
            '		    <div ng-show="(!detail.editando && detail.Tipo != 4) || detail.Tipo == 4">{{detail.TipoDescricao}}</div>' +
            '           <select class="form-control input-sm" style="height:22px; font-size:9px"' +
            '                   ng-model="detail.TipoMaterial"' +
            '                   ng-show="detail.editando && detail.Tipo != 4"' +
            '                   ng-options="tipo.Nome for tipo in listaTipoMaterial track by tipo.Id" required>' +
            '               <option style="display:none" value=""> Selecione o tipo </option>' +
            '           </select>' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2 text-center">' +
            `		<div ng-show="(!detail.editando && detail.Tipo != 4) || detail.Tipo == 4" ng-class="{'texto': !detail.open, 'textoBold': detail.open}">{{detail.Codigo}}</div>` +
            '       <input ng-show="detail.editando && detail.Tipo != 4" type="text" style="text-align: left;" class="form-control input-xs text-left" placeholder="Código" ng-model="detail.Codigo" ng-keyup="detail.Codigo = detail.Codigo" >' +
            '		</div>' +
            '		<div class="col-lg-6 col-md-6 col-sm-6 text-left">' +
            `		<div ng-show="(!detail.editando && detail.Tipo != 4) || detail.Tipo == 4" ng-class="{'texto': !detail.open, 'textoBold': detail.open}">{{detail.Descricao}}</div>` +
            '       <input ng-show="detail.editando && detail.Tipo != 4" style="text-align: left;" type="text" class="form-control input-xs" placeholder="Descrição" ng-model="detail.Descricao" ng-keyup="detail.Descricao = detail.Descricao" >' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2 text-center">' +
            '		    <div ng-show="(!detail.editando && detail.Tipo != 4) || detail.Tipo == 4">{{detail.Unidade}}</div>' +
            '	        <select class="form-control input-sm" style="height:22px; font-size:9px"'+
            '                   ng-model="detail.UnidadeMedida" '+
            '                   ng-show="detail.editando && detail.Tipo != 4"'+
            '                   ng-options="unidade.TextoUnidadeView for unidade in listaUnidade track by unidade.Id" required>' +
            '	            <option style="display:none" value=""> Unidade de referência </option>' +
            '	        </select>' +
            '		    </div>' +
            '	    </div>' +
            '	</div>' +
            '	<div class="col-lg-6 col-md-6 col-sm-6 text-right">' +
            '	    <div class="row">' +
            '		    <div class="col-lg-2 col-md-2 col-sm-2">' +
            '			    <formata-numero ng-show="(!detail.editando && detail.Tipo != 4) || detail.Tipo == 4" format-valor="detail.ValorUnitario" format-tipo="\'real\'"></formata-numero>' +
            '               <input ng-show="detail.editando && detail.Tipo != 4" type="text" class="form-control input-xs" placeholder="Valor Unitário (R$)" maxlength="16" ng-model="detail.ValorUnitario" ng-keyup="detail.CustoUnitario = detail.ValorUnitario" ui-number-mask="decimals" required>' +
            '		    </div>' +
            '		    <div class="col-lg-2 col-md-2 col-sm-2">' +
            '			    <formata-numero ng-show="!detail.editando" format-valor="detail.Coeficiente" format-tipo="\'coeficiente\'"></formata-numero>' +
            '               <input ng-show="detail.editando" type="text" class="form-control input-xs" placeholder="Consumo" ng-model="detail.Consumo" ng-init="detail.Consumo = detail.Coeficiente" ng-keyup="detail.Coeficiente = detail.Consumo" ui-number-mask="7" required>' +
            '		    </div>' +
            '		    <div class="col-lg-2 col-md-2 col-sm-2">' +
            '			    <formata-numero format-valor="detail.Custo" format-tipo="\'real\'"></formata-numero>' +
            '		    </div>' +
            '		    <div class="col-lg-2 col-md-2 col-sm-2">' +
            '			    <formata-numero format-valor="detail.EncargoSocial" format-tipo="\'real\'" ng-show="(construcao.EncargoSocial > 0) && comEncargos"></formata-numero>' +
            '		    </div>' +
            '		    <div class="col-lg-2 col-md-2 col-sm-2">' +
            '			    <formata-numero format-valor="detail.BDI" format-tipo="\'real\'" ng-show="((construcao.BDIMaoObra > 0 || construcao.BDIMaterial > 0) || (construcao.BDIMaoObra == 0 && construcao.BDIMaterial == 0 && construcao.BDI > 0)) && comBDI"></formata-numero>' +
            '		    </div>' +
            '		    <div class="col-lg-2 col-md-2 col-sm-2">' +
            '		        <formata-numero ng-show="comEncargos && comBDI" format-valor="detail.CustoTotal" format-tipo="\'real\'"></formata-numero>' +
            '			    <formata-numero ng-show="!comEncargos && comBDI" format-valor="detail.CustoBDI" format-tipo="\'real\'"></formata-numero>' +
            '			    <formata-numero ng-show="comEncargos && !comBDI" format-valor="detail.CustoEncargos" format-tipo="\'real\'"></formata-numero>' +
            '			    <formata-numero ng-show="!comEncargos && !comBDI" format-valor="detail.Custo" format-tipo="\'real\'"></formata-numero>' +
            '		    </div>' +
            '	    </div>' +
            '	    <div class="row" ng-show="mouseoverinsumo || detail.editando || detail.open">' +
            '		<div class="col-lg-12 col-md-12 col-sm-12 text-right">' +
            '           <div ng-show="!detail.editando">' +
            `               <itemaddsub ng-show="detail.Tipo == 4 && detail.open" ng-click="addInsumoCompAux(detail); $event.stopPropagation();" btn-permissao="'SET_ORCAMENTO'" btn-acessos="construcao.Acessos"></itemaddsub>` +
            '               <itemeditar ng-show="!detail.open" ng-click="alterarInsumo(detail); $event.stopPropagation();" btn-permissao="\'SET_ORCAMENTO\'" btn-acessos="construcao.Acessos"></itemeditar>' +
            '               <itemexcluir ng-show="!detail.open" ng-click="delInsumoComp(item, subItem, detail); $event.stopPropagation();" btn-permissao="\'DEL_ORCAMENTO\'" btn-acessos="construcao.Acessos"></itemexcluir>' +
            '               <itemabrir ng-show="detail.Tipo == 4 && !detail.open" ng-click="(!detail.editando && getInsumoComp(detail)); $event.stopPropagation();"></itemabrir>' +
            '               <itemfechar ng-show="detail.Tipo == 4 && detail.open" ng-click="(!detail.editando && getInsumoComp(detail)); $event.stopPropagation();"></itemfechar>' +
            '		    </div>' +
            '           <div ng-show="detail.editando">' +
            '               <itemsalvar ng-click="salvarInsumo(item, subItem, detail); $event.stopPropagation();" ></itemsalvar>' +
            '               <itemcancelar ng-click="cancelarInsumo(subItem, detail); $event.stopPropagation();"></itemcancelar>' +
            '		    </div>' +
            '		</div>' +
            '	    </div>' +
            '	</div>' +
            '	</div>' +
            '	<div class="row" ng-show="detail.Novo">' +
            '     <div class="notShowMobile" dynamic="detail.HtmlEditarInsumo"></div>' +
            '	</div>' +
            '	<div>' +
            '     <div class="notShowMobile" dynamic="detail.HtmlListaInsumoComp"></div>' +
            '	</div>' +
            '    </li>' +
            '</ul>' +
            '</div>';
    }

    $scope.getHtmlListaInsumoMobile = () => {
        return '' +
        '<br ng-show="subItem.open && !subItem.Novo" />' +
        '<div class="panel panel-crudlist-mini" ng-show="subItem.open && !subItem.Novo">' +
        '<div class="panel-heading tr-fonteTitulo">' +
        '   <div class="row">' +
        '	<div class="col-xs-12">' +
        '           Detalhe da Composição' +
        '	</div>' +
        '   </div>' +
        '</div>' +
        '<ul class="list-group tr-fonteItem">' +
        '    <li class="list-group-item LinhaLista" ng-repeat="insumo in subItem.Itens">' +
        '	<div class="row">' +
        '	<div class="col-xs-12">' +
        '		<p>' +
        '		{{insumo.TipoDescricao}}' +
        '		</p>' +
        '		<p>' +
        '		Código: {{insumo.Codigo}}' +
        '		</p>' +
        '		<p>' +
        '		Descrição: {{insumo.Descricao}}' +
        '		</p>' +
        '		<p>' +
        '		Unidade: {{insumo.Unidade}}' +
        '		</p>' +
        '		<p>' +
        '		    <span ng-show="!insumo.editando">Valor Unit: <formata-numero format-valor="insumo.ValorUnitario" format-tipo="\'real\'"></formata-numero></span>' +
        '           <input ng-show="insumo.editando" type="text" class="form-control input-xs" placeholder="Valor Unitário (R$)" maxlength="16" ng-model="insumo.ValorUnitario" ng-keyup="insumo.CustoUnitario = insumo.ValorUnitario" ui-number-mask="decimals" required>' +
        '		</p>' +
        '		<p>' +
        '		    <span ng-show="!insumo.editando">Consumo: <formata-numero format-valor="insumo.Coeficiente" format-tipo="\'coeficiente\'"></formata-numero></span>' +
        '           <input ng-show="insumo.editando" type="text" class="form-control input-xs" placeholder="Consumo" ng-model="insumo.Consumo" ng-init="insumo.Consumo = insumo.Coeficiente" ng-keyup="insumo.Coeficiente = insumo.Consumo" ui-number-mask="7" required>' +
        '		</p>' +
        '		<p>' +
        '			Custo: <formata-numero format-valor="insumo.Custo" format-tipo="\'real\'"></formata-numero>' +
        '		</p>' +
        '		<p ng-show="comEncargos">' +
        '			Enc. Social: <formata-numero format-valor="insumo.EncargoSocial" format-tipo="\'real\'"></formata-numero>' +
        '		</p>' +
        '		<p ng-show="comBDI">' +
        '			BDI: <formata-numero format-valor="insumo.BDI" format-tipo="\'real\'"></formata-numero>' +
        '		</p>' +
        '		<p>' +
        '			Custo Total: <formata-numero ng-show="comEncargos && comBDI" format-valor="insumo.CustoTotal" format-tipo="\'real\'"></formata-numero>' +
        '			<formata-numero ng-show="!comEncargos && comBDI" format-valor="insumo.CustoBDI" format-tipo="\'real\'"></formata-numero>' +
        '			<formata-numero ng-show="comEncargos && !comBDI" format-valor="insumo.CustoEncargos" format-tipo="\'real\'"></formata-numero>' +
        '			<formata-numero ng-show="!comEncargos && !comBDI" format-valor="insumo.Custo" format-tipo="\'real\'"></formata-numero>' +
        '		</p>' +
        '		<p ng-show="mouseoverinsumo || insumo.editando">' +
        '           <div ng-show="!insumo.editando">' +
        '               <itemeditar ng-click="alterarInsumo(insumo); $event.stopPropagation();" btn-permissao="\'SET_ORCAMENTO\'" btn-acessos="construcao.Acessos"></itemeditar>' +
        '               <itemexcluir ng-click="delInsumoComp(item, subItem, insumo); $event.stopPropagation();" btn-permissao="\'DEL_ORCAMENTO\'" btn-acessos="construcao.Acessos"></itemexcluir>' +
        '		    </div>' +
        '           <div ng-show="insumo.editando">' +
        '               <itemsalvar ng-click="salvarInsumo(item, subItem, insumo); $event.stopPropagation();" ></itemsalvar>' +
        '               <itemcancelar ng-click="cancelarInsumo(subItem, insumo); $event.stopPropagation();"></itemcancelar>' +
        '		    </div>' +
        '		</p>' +
        '	</div>' +
        '	</div>' +
        '    </li>' +
        '</ul>' +
        '</div>';
    }

    $scope.getHtmlEditarInsumo = () => {
        return '' +
            '<form role="form" class="form" name="formInsumo">' +
            '   <div class="col-lg-10 col-md-10 col-sm-10 col-xs-12">' +
            '       <div class="form-group">' +
            '           <div class="row">' +
            '               <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '                   <label>Base</label>' +
            `                   <select class="form-control" ng-model="detail.IdBaseOrigem" ng-init="detail.IdBaseOrigem = sessao.BasePublica ? sessao.BasePublica.IdBaseOrigem : '0'" ng-change="getComposicaoDisponivel(detail)">` +
            '                       <option ng-repeat="base in listaOrigemDisponivel" value="{{base.Id}}">{{base.Nome}}</option>' +
            '                   </select>' +
            '               </div>' +
            '               <div class="col-lg-9 col-md-9 col-sm-9 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            `                   <label>{{detail.IdBaseOrigem == 0 ? 'Obras' : 'Período'}}</label>` +
            `                   <select class="form-control" ng-model="detail.IdOrigem"  ng-init="detail.IdOrigem = sessao.BasePublica ? sessao.BasePublica.IdOrigem : '0'" ng-change="setBaseSessao(detail)">` +
            '                       <option ng-repeat="base in listaComposicaoDisponivel" value="{{base.Id}}">{{base.Descricao}}</option>' +
            '                   </select>' +
            '               </div>' +
            '               <div class="row col-lg-12 col-md-12 col-sm-12 col-xs-12">&nbsp;</div>' +
            '               <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '                   <label>Insumo</label>'+
            '                   <dropdowncomplete' +
            '                       ddc-placeholder="\'Digite o Insumo\'"' +
            '                       ddc-mensagemvazio="\'NENHUM INSUMO ENCONTRADO\'"' +
            '                       ddc-showcodigo="true"' +
            '                       ddc-showvalor="true"' +
            '                       ddc-hideadd="true"' +
            '                       ddc-construcao="construcao"' +
            '                       ddc-item="detail"' +
            '                       ddc-lista="listaInsumo"' +
            '                       set-selecionado="setSelecionadoInsumo(selecionado,detail)"' +
            '                       get-lista="getListaInsumo(texto,detail)"' +
            '                       click-add="novoInsumo()">' +
            '                   </dropdowncomplete>' +
            '               </div>' +
            '           </div>' +
            '       </div>' +
            '       <div class="form-group">' +
            '           <div class="row">' +
            '               <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '					<label>Consumo {{!detail.UnidadeSigla ? "" : ("("+detail.UnidadeSigla+")")}}</label>' +
            '					<input type="text" class="form-control" placeholder="Consumo" ng-model="detail.Consumo" ui-number-mask="7" required>' +
            '               </div>' +
            '				<div class="col-lg-2 col-md-2 col-sm-4 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '					<label>Preço ({{construcao.Moeda}})</label>' +
            '					<div class="text-left panel-fonticon" ng-show="detail.Selecionado">' +
            '					    <formata-numero format-valor="detail.CustoUnitario" format-tipo="\'real\'"></formata-numero>' +
            '					</div>' +
            '                   <input type="text" class="form-control" placeholder="Valor Unitário (R$)" maxlength="16" ng-model="detail.CustoUnitario" ui-number-mask="decimals" ng-show="!detail.Selecionado" required>' +
            '               </div>' +
            '               <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12" ng-show="!detail.Selecionado">' +
            '                   <label>Tipo Insumo</label>'+
            '                   <select class="form-control"' +
            '                       ng-model="detail.TipoSelecionado"' +
            '                       ng-options="tipo.Descricao for tipo in listaTipoMaterial track by tipo.Id" required>' +
            '                       <option style="display:none" value=""> Selecione o tipo </option>' +
            '                   </select>' +
            '               </div>' +
            '               <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12" ng-show="!detail.Selecionado">' +
            '                   <br class="showMobile" />' +
            '                   <label>Unidade</label>'+
            '	                <select class="form-control" ng-model="detail.IdUnidade" ng-init="detail.IdUnidade = detail.IdUnidade + \'\'" ng-change="setUnidadeSigla(detail)" required>' +
            '	                    <option value="" selected disabled> Unidade de referência </option>' +
            '	                    <option ng-repeat="unidade in listaUnidade" value="{{unidade.Id}}">{{unidade.Descricao}} ({{unidade.Sigla}})</option>' +
            '	                </select>' +
            '               </div>' +
            '               <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12" ng-show="!detail.Selecionado">' +
            '                   <br class="showMobile" />' +
            '                   <label>Código</label>'+
            '	                <input type="text" class="form-control" placeholder="Código" maxlength="20" ng-model="detail.Codigo"/>' +
            '               </div>' +
            '           </div>' +
            '       </div>' +
            '   </div>' +
            '   <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12 text-center">' +
            '       <div class="row">' +
            '           <itemsalvar ng-click="salvarInsumo(item, subItem, detail); $event.stopPropagation();" ></itemsalvar>' +
            '           <itemcancelar ng-click="cancelarInsumo(subItem, detail); $event.stopPropagation();"></itemcancelar>' +
            '		</div>' +
            '       <div class="row text-center"><br />' +
            '           <label>Total</label>' +
            '			<div class="panel-fonticon">' +
            '			    <formata-numero format-valor="detail.Consumo*detail.CustoUnitario" format-tipo="\'real\'"></formata-numero>' +
            '			</div>' +
            '		</div>' +
            '   </div>' +
            '</form>';
    }

    $scope.getInsumoComp = (composicao) => {
        composicao.open = !composicao.open;
        if (composicao.open) {
            var caminho = composicao.Caminho.filter(c => c != 0);
            caminho.push(composicao.Id);
            composicao.Itens = $scope.composicoesBasePropria.filter(c => c.Id == composicao.Id)[0].Itens;
            composicao.Itens.forEach(i => {
                i.Caminho = caminho;
            })
            composicao.HtmlListaInsumoComp = $scope.getHtmlListaInsumoComp(composicao);
        }
        else
            composicao.HtmlListaInsumoComp = '';
    }
    
    $scope.addInsumoCompAux = (detail) => {
        var caminho = detail.Caminho.filter(c => c != 0);
        caminho.push(detail.Id);
        var item = {
            IdCount: $scope.orcamento.length + 1,
            Id: 0,
            Tipo: '',
            Codigo: '',
            Unidade: '',
            Nome: '',
            Descricao: '',
            CustoUnitario: '',
            Consumo: '',
            Caminho: caminho,
            Novo: true
        };

        detail.Itens.unshift(item);
        item.HtmlEditarInsumo = $scope.getHtmlEditarInsumoComp(detail);
    }

    $scope.setInsumoComposicao = (etapa, composicao, item) => {

        var insumoComp = {
            IdConstrucao: etapa.IdConstrucao,
            IdObraOrigem: item.IdObraOrigem ? item.IdObraOrigem : etapa.IdConstrucao,
            IdComposicao: composicao.Id ? composicao.Id : composicao.IdMaterial,
            IdMaterial: item.Id,
            Coeficiente: item.Consumo,
            Tipo: item.Tipo ? item.Tipo : 1
        }

        if (item.Origem == 0)
            insumoComp.Importado = item.Importado;
        else {
            insumoComp.IdBasePublica = item.IdBasePublica;
            insumoComp.UF = item.UF;
            insumoComp.Periodo = item.Periodo;
        }


        item.editando = false;
        Material.setInsumoComposicao(insumoComp, 
            (data) => {
                if (data.Code == 0) {
                    $scope.AtualizaValorObraEtapa();
                    $scope.getCustoDetalhadoEtapaConstrucao(etapa, () => {
                        $scope.getComposicoes(() => {
                            $scope.getComposicaoUpdate(etapa, composicao);
                        });
                    });
                }
            }
        );

    }

    $scope.delInsumoComp = (etapa, composicao, insumo) => {

        function delInsumoComposicao (params, etapa) {
            Material.delInsumoComposicao(params, () => {
                $scope.AtualizaValorObraEtapa();
                $scope.getCustoDetalhadoEtapaConstrucao(etapa, () => {
                    $scope.getComposicoes(() => {
                        $scope.getComposicaoUpdate(etapa, composicao);
                    });
                });
            });
        }

        var params = {
            IdConstrucao: $scope.construcao.Id,
            IdComposicao: composicao.Id ? composicao.Id : composicao.IdMaterial,
            IdMaterial: insumo.Id
        }
        
        if (composicao.Itens.length-1 == 0)
            MsgBox.Pergunta('Atenção', 'A exclusão do ' + insumo.TipoDescricao + ' implicará na exclusão da composição que poderá impactar no orçamento, no financeiro e na medição física.  Confirma exclusão?'
                , () => {
                    var idx = etapa.Itens.findIndex(i => i.IdCompra == composicao.IdCompra);
                    etapa.Itens.splice(idx, 1);
    
                    Material.delMaterialOrcamento(composicao.IdCompra,
                        (data) => {
                            $scope.AtualizaValorObraEtapa();
                            $scope.getCustoDetalhadoEtapaConstrucao(etapa, () => {
                                $scope.getComposicoes(() => {});
                            });
                        }
                    );
    
                }
                , () => {
            });
        else {
            var idx = composicao.Itens.findIndex(i => i.Id == insumo.Id);
            composicao.Itens.splice(idx, 1);
            delInsumoComposicao(params, etapa);
        }
    }

    $scope.getHtmlListaInsumoComp = (composicao) => {
        $scope.composicaoListaInsumos = composicao;
        var IdComp = composicao.Id;
        var retorno = '' +
            '<br />' +
            '<div class="panel panel-insumo sombreado">' +
            '<div class="panel-heading tr-fonteTitulo">' +
            '    <div class="row">' +
            '	<div class="col-lg-6 col-md-6 col-sm-6">' +
            '	    <div class="row">' +
            '		<div class="col-lg-2 col-md-2 col-sm-2 text-center">' +
            '	        Tipo' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2 text-center">' +
            '	        Código' +
            '		</div>' +
            '		<div class="col-lg-6 col-md-6 col-sm-6 text-left">' +
            '	        Insumo' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2 text-center">' +
            '	        Unidade' +
            '		</div>' +
            '	    </div>' +
            '	</div>' +
            '	<div class="col-lg-6 col-md-6 col-sm-6 text-right">' +
            '	    <div class="row">' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		    Preço' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		    Consumo' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		    Custo' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		    Total' +
            '		</div>' +
            '	    </div>' +
            '	</div>' +
            '    </div>' +
            '</div>' +
            '<ul class="list-group tr-fonteItem">';

        retorno += 
            `<ul class="list-group tr-fonteItem" ng-init="composicao${IdComp} = composicaoListaInsumos">` +
            `    <li class="list-group-item LinhaLista" ng-class="{'LinhaLista': detail.Tipo != 4, 'LinhaListaHand': detail.Tipo == 4}" ng-repeat="detail in composicao${IdComp}.Itens" ng-mouseover="mouseoverinsumo${IdComp}= (true && detail.TipoDescricao)" ng-mouseleave="mouseoverinsumo${IdComp}=false" ng-click="(detail.Tipo == 4 && !detail.Novo && !detail.editando && getInsumoComp(detail)); $event.stopPropagation();">` +
            '	<div class="row" ng-show="!detail.Novo && !detail.TipoDescricao">' +
            '           <loadcirclesmall ng-show="!detail.TipoDescricao"></loadcirclesmall>' +
            '	</div>' +
            '	<div class="row" ng-show="!detail.Novo && detail.TipoDescricao">' +
            '	<div class="col-lg-6 col-md-6 col-sm-6">' +
            '	    <div class="row">' +
            '		<div class="col-lg-2 col-md-2 col-sm-2 text-center">' +
            '		    <div ng-show="(!detail.editando && detail.Tipo != 4) || detail.Tipo == 4">{{detail.TipoDescricao}}</div>' +
            '           <select class="form-control input-sm" style="height:22px; font-size:9px"' +
            '                   ng-model="detail.TipoMaterial"' +
            '                   ng-show="detail.editando && detail.Tipo != 4"' +
            '                   ng-options="tipo.Nome for tipo in listaTipoMaterial track by tipo.Id" required>' +
            '               <option style="display:none" value=""> Selecione o tipo </option>' +
            '           </select>' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2 text-center">' +
            `		<div ng-show="!detail.editando" ng-class="{'texto': !detail.open, 'textoBold': detail.open}">{{detail.Codigo}}</div>` +
            '       <input ng-show="detail.editando" type="text" style="text-align: left;" class="form-control input-xs text-left" placeholder="Código" ng-model="detail.Codigo" ng-keyup="detail.Codigo = detail.Codigo" >' +
            '		</div>' +
            '		<div class="col-lg-6 col-md-6 col-sm-6 text-left">' +
            `		<div ng-show="!detail.editando" ng-class="{'texto': !detail.open, 'textoBold': detail.open}">{{detail.Descricao}}</div>` +
            '       <input ng-show="detail.editando" style="text-align: left;" type="text" class="form-control input-xs" placeholder="Descrição" ng-model="detail.Descricao" ng-keyup="detail.Descricao = detail.Descricao" >' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2 text-center">' +
            '		    <div ng-show="!detail.editando">{{detail.Unidade}}</div>' +
            '	        <select class="form-control input-sm" style="height:22px; font-size:9px"'+
            '                   ng-model="detail.UnidadeMedida" '+
            '                   ng-show="detail.editando"'+
            '                   ng-options="unidade.TextoUnidadeView for unidade in listaUnidade track by unidade.Id" required>' +
            '	            <option style="display:none" value=""> Unidade de referência </option>' +
            '	        </select>' +
            '		    </div>' +
            '	    </div>' +
            '	</div>' +
            '	<div class="col-lg-6 col-md-6 col-sm-6 text-right">' +
            '	    <div class="row">' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '			<formata-numero ng-show="(!detail.editando && detail.Tipo != 4) || detail.Tipo == 4" format-valor="detail.ValorUnitario" format-tipo="\'real\'"></formata-numero>' +
            '           <input ng-show="detail.editando && detail.Tipo != 4" type="text" class="form-control input-xs" placeholder="Valor Unitário (R$)" maxlength="16" ng-model="detail.ValorUnitario" ng-keyup="detail.CustoUnitario = detail.ValorUnitario" ui-number-mask="decimals" required>' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '			<formata-numero ng-show="!detail.editando" format-valor="detail.Coeficiente" format-tipo="\'coeficiente\'"></formata-numero>' +
            '           <input ng-show="detail.editando" type="text" class="form-control input-xs" placeholder="Consumo" ng-model="detail.Consumo" ng-init="detail.Consumo = detail.Coeficiente" ng-keyup="detail.Coeficiente = detail.Consumo" ui-number-mask="7" required>' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '			<formata-numero format-valor="detail.Coeficiente*detail.ValorUnitario" format-tipo="\'real\'"></formata-numero>' +
            '		</div>' +
            `		<div class="col-lg-2 col-md-2 col-sm-2">` +
            '		</div>' +
            `		<div class="col-lg-2 col-md-2 col-sm-2">` +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		    <formata-numero format-valor="detail.Coeficiente*detail.ValorUnitario" format-tipo="\'real\'"></formata-numero>' +
            '		</div>' +
            '	    </div>' +
            `	    <div class="row" ng-show="(!detail.editando && mouseoverinsumo${IdComp}) || detail.editando || detail.open">` +
            `		<div class="col-lg-12 col-md-12 col-sm-12 text-right">` +
            '           <div ng-show="!detail.editando">' +
            `               <itemaddsub ng-show="detail.Tipo == 4 && detail.open" ng-click="addInsumoCompAux(detail); $event.stopPropagation();" btn-permissao="'SET_ORCAMENTO'" btn-acessos="construcao.Acessos"></itemaddsub>` +
            '               <itemeditar ng-show="!detail.open" ng-click="alterarInsumo(detail); $event.stopPropagation();" btn-permissao="\'SET_ORCAMENTO\'" btn-acessos="construcao.Acessos"></itemeditar>' +
            `               <itemexcluir ng-show="!detail.open" ng-click="delInsumoComp(item, composicao${IdComp}, detail); $event.stopPropagation();" btn-permissao="\'DEL_ORCAMENTO\'" btn-acessos="construcao.Acessos"></itemexcluir>` +
            '               <itemabrir ng-show="detail.Tipo == 4 && !detail.open" ng-click="(detail.Tipo == 4 && !detail.Novo && !detail.editando && getInsumoComp(detail)); $event.stopPropagation();"></itemabrir>' +
            '               <itemfechar ng-show="detail.Tipo == 4 && detail.open" ng-click="(detail.Tipo == 4 && !detail.Novo && !detail.editando && getInsumoComp(detail)); $event.stopPropagation();"></itemfechar>' +
            '		    </div>' +
            '           <div ng-show="detail.editando">' +
            `               <itemsalvar ng-click="salvarInsumo(item,composicao${IdComp}, detail); $event.stopPropagation();" ></itemsalvar>` +
            `               <itemcancelar ng-click="cancelarInsumo(composicao${IdComp}.Itens,detail); $event.stopPropagation();"></itemcancelar>` +
            '		    </div>' +
            '		</div>' +
            '	    </div>' +
            '	</div>' +
            '	</div>' +
            '	<div class="row" ng-show="detail.Novo">' +
            '     <div class="notShowMobile" dynamic="detail.HtmlEditarInsumo"></div>' +
            '	</div>' +
            '	<div>' +
            '     <div class="notShowMobile" dynamic="detail.HtmlListaInsumoComp"></div>' +
            '	</div>' +
            '    </li>' +
            '</ul>' +
            '</div>';

    
        return retorno;
    }

    $scope.getHtmlEditarInsumoComp = (composicao) => {
        $scope.composicaoAuxListaInsumos = composicao;
        return '' +
            `<form role="form" class="form" name="formInsumo">` +
            '   <div class="col-lg-10 col-md-10 col-sm-10 col-xs-12">' +
            '       <div class="form-group">' +
            '           <div class="row">' +
            '               <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '                   <label>Base</label>' +
            `                   <select class="form-control" ng-model="detail.IdBaseOrigem" ng-init="detail.IdBaseOrigem = sessao.BasePublica ? sessao.BasePublica.IdBaseOrigem : '0'" ng-change="getComposicaoDisponivel(detail)">` +
            '                       <option ng-repeat="base in listaOrigemDisponivel" value="{{base.Id}}">{{base.Nome}}</option>' +
            '                   </select>' +
            '               </div>' +
            '               <div class="col-lg-9 col-md-9 col-sm-9 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            `                   <label>{{detail.IdBaseOrigem == 0 ? 'Obras' : 'Período'}}</label>` +
            `                   <select class="form-control" ng-model="detail.IdOrigem"  ng-init="detail.IdOrigem = sessao.BasePublica ? sessao.BasePublica.IdOrigem : '0'" ng-change="setBaseSessao(detail)">` +
            '                       <option ng-repeat="base in listaComposicaoDisponivel" value="{{base.Id}}">{{base.Descricao}}</option>' +
            '                   </select>' +
            '               </div>' +
            '			    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '                   <label>Insumo</label>'+
            '                   <dropdowncomplete' +
            '                       ddc-placeholder="\'Digite o Insumo\'"' +
            '                       ddc-mensagemvazio="\'NENHUM INSUMO ENCONTRADO\'"' +
            '                       ddc-showcodigo="true"' +
            '                       ddc-showvalor="true"' +
            '                       ddc-hideadd="true"' +
            '                       ddc-construcao="construcao"' +
            '                       ddc-item="detail"' +
            '                       ddc-lista="listaInsumo"' +
            '                       set-selecionado="setSelecionadoInsumo(selecionado,detail)"' +
            '                       get-lista="getListaInsumo(texto,detail)"' +
            '                       click-add="novoInsumo()">' +
            '                   </dropdowncomplete>' +
            '               </div>' +
            '           </div>' +
            '       </div>' +
            '       <div class="form-group">' +
            '           <div class="row">' +
            '               <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '					<label>Consumo {{!detail.UnidadeSigla ? "" : ("("+detail.UnidadeSigla+")")}}</label>' +
            '					<input type="text" class="form-control" placeholder="Consumo" ng-model="detail.Consumo" ui-number-mask="7" required>' +
            '               </div>' +
            '				<div class="col-lg-2 col-md-2 col-sm-4 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '					<label>Preço ({{construcao.Moeda}})</label>' +
            '					<div class="text-left panel-fonticon" ng-show="detail.Selecionado">' +
            '					    <formata-numero format-valor="detail.CustoUnitario" format-tipo="\'real\'"></formata-numero>' +
            '					</div>' +
            '                   <input type="text" class="form-control" placeholder="Valor Unitário (R$)" maxlength="16" ng-model="detail.CustoUnitario" ui-number-mask="decimals" ng-show="!detail.Selecionado" required>' +
            '               </div>' +
            '               <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12" ng-show="!detail.Selecionado">' +
            '                   <label>Tipo Insumo</label>'+
            '                   <select class="form-control"' +
            '                       ng-model="detail.TipoSelecionado"' +
            '                       ng-options="tipo.Descricao for tipo in listaTipoMaterial track by tipo.Id" required>' +
            '                       <option style="display:none" value=""> Selecione o tipo </option>' +
            '                   </select>' +
            '               </div>' +
            '               <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12" ng-show="!detail.Selecionado">' +
            '                   <br class="showMobile" />' +
            '                   <label>Unidade</label>'+
            '	                <select class="form-control" ng-model="detail.IdUnidade" ng-init="detail.IdUnidade = detail.IdUnidade + \'\'" ng-change="setUnidadeSigla(detail)" required>' +
            '	                    <option value="" selected disabled> Unidade de referência </option>' +
            '	                    <option ng-repeat="unidade in listaUnidade" value="{{unidade.Id}}">{{unidade.Descricao}} ({{unidade.Sigla}})</option>' +
            '	                </select>' +
            '               </div>' +
            '               <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12" ng-show="!detail.Selecionado">' +
            '                   <br class="showMobile" />' +
            '                   <label>Código</label>'+
            '	                <input type="text" class="form-control" placeholder="Código" maxlength="20" ng-model="detail.Codigo"/>' +
            '               </div>' +
            '           </div>' +
            '       </div>' +
            '   </div>' +
            '   <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12 text-center">' +
            '       <div class="row">' +
            '           <itemsalvar ng-click="salvarInsumo(item, composicaoAuxListaInsumos, detail); $event.stopPropagation();" ></itemsalvar>' +
            `           <itemcancelar ng-click="cancelarInsumo(composicaoAuxListaInsumos, detail); $event.stopPropagation();"></itemcancelar>` +
            '		</div>' +
            '       <div class="row text-center"><br />' +
            '           <label>Total</label>' +
            '			<div class="panel-fonticon">' +
            '			    <formata-numero format-valor="detail.Consumo*detail.CustoUnitario" format-tipo="\'real\'"></formata-numero>' +
            '			</div>' +
            '		</div>' +
            '   </div>' +
            '</form>';
    }    
    /* FIM EDITAR MATERIAL* */

    $scope.getListaConstrucao = (callBack) => {
        var params = {
            permissao: 'GET_ORCAMENTO', 
            refresh: $scope.refreshObra
        }
        $scope.getListaObraCache(params, 
            (obras) => {
                $scope.construcoes = obras
                if ($scope.refreshCargaArquivo) {
                    Construcao.getCargaArquivoObra(
                        (cargas) => {
                            if (cargas.Instance.some(c => obras.some(o => o.Id == c.IdConstrucao))) {
                                $scope.ObraSelecionada = obras.filter(o => cargas.Instance.some(c => o.Id == c.IdConstrucao))[0]
                                
                                var carga = cargas.Instance.filter(c => c.IdConstrucao == $scope.ObraSelecionada.Id)[0]
                                $scope.ObraSelecionada.CargaArquivo = `Já foram carregados ${carga.LinhaCarga} do total de ${carga.LinhaTotal} registros...`
                                $scope.ObraSelecionada.PercentualCarga = carga.Percentual

                                $scope.construcao = $scope.ObraSelecionada

                                $scope.timeIntervalCarga = setInterval(() => {
                                    $scope.verificaCargaArquivo($scope.ObraSelecionada)
                                }, 5000)
        
                            }

                            $scope.refreshCargaArquivo = false
                            callBack()
                        }
                    )            
                }
                else {
                    callBack()
                }
            }
        )
    }

    $scope.filtraObra = (obra) => {
        if (obra && obra.id) {
            $scope.setObraSelecionada($scope.construcoes.filter(c => c.Id == obra.id)[0])
        }
        else {
            // $scope.notasfiscais = []
            $scope.orcamento = undefined;
            $scope.construcao = undefined;
            CacheApp.delConstrucao();
            $scope.listaRelatorio = [];
        }
    }

    $scope.setObraSelecionada = (obra) => {
        $scope.orcamento = undefined;
        $scope.construcao = obra;
        CacheApp.setConstrucao(obra);
        
        $scope.comEncargos = ($scope.construcao.EncargoSocial > 0)
        $scope.comBDI = $scope.construcao.BDI > 0 || $scope.construcao.BDIMaoObra > 0 || $scope.construcao.BDIMaterial > 0 || $scope.construcao.BDIEquipamento > 0 || $scope.construcao.BDIServico > 0 || $scope.construcao.BDITaxa > 0
        $scope.HtmlManterObra = undefined

        $scope.listaRelatorio = [];
        $scope.listaRelatorio = $scope.reportList.filter(r => obra.Acessos.indexOf(r.Permissao) >= 0);

        $scope.getEtapasConstrucao();
        $scope.getComposicoes(() => {});

        $scope.getOrigemBase();
        $scope.getListaUnidades();
        $scope.getTipoMaterial();
    }

    $scope.verificaCargaArquivo = (obra) => {
        Construcao.getCargaArquivoObra(
            (data) => {
                if (data.Instance.some(c => c.IdConstrucao == obra.Id)) {
                    var carga = data.Instance.filter(c => c.IdConstrucao == obra.Id)[0]
                    obra.CargaArquivo = `Já foram carregados ${carga.LinhaCarga} do total de ${carga.LinhaTotal} registros...`
                    obra.PercentualCarga = carga.Percentual
                }
                else {
                    obra.CargaArquivo = undefined
                    clearInterval($scope.timeIntervalCarga)
                    $scope.setObraSelecionada(obra)
                }
            }
        )
    }

    $scope.editarObra = () => {
        if (!$scope.HtmlManterObra)
            $scope.HtmlManterObra = `
                <manterobra mo-obra="construcao">
                </manterobra>
            `;
        $scope.openObra = !$scope.openObra;
        if (!$scope.openObra && $scope.construcao.Novo)
            $scope.loadObra()
    }

    $scope.adicionarObra = () => {
        if ($scope.sessao.TipoPlano == 3 && $scope.construcoes && $scope.construcoes.length > 2) {
            CacheApp.msgBoxAcessoPremium();
            return;
        }

        $scope.construcao = { Tipo: 0, Dono: true, Novo: true }
        $scope.editarObra()
    }

    $scope.salvarObra = () => {
        $rootScope.$broadcast('salvarObra', {});
    }

    $scope.$on('refreshComboObra', (events,args) => {
        $scope.refreshObra = true
        $scope.loadObra()
    })

    $scope.loadObra = () => {
        $scope.ObraSelecionada = CacheApp.getConstrucao()
        CacheApp.delConstrucao()
        $scope.AtualizaConstrucao()
        $scope.getListaConstrucao(()=>{
            if ($scope.ObraSelecionada && $scope.construcoes.some(c => c.Id == $scope.ObraSelecionada.Id)) {
                $scope.ObraSelecionada = $scope.construcoes.filter(c => c.Id == $scope.ObraSelecionada.Id)[0]
                $scope.listaSelecao = {
                    id: $scope.ObraSelecionada.Id, 
                    model: $scope.ObraSelecionada.Titulo, 
                    label: $scope.ObraSelecionada.Titulo,
                    checked: true
                }
                if ($scope.ObraSelecionada.CargaArquivo)
                    $scope.verificaCargaArquivo($scope.ObraSelecionada)
                else
                    $scope.setObraSelecionada($scope.ObraSelecionada)
            }
            else {
                $scope.ObraSelecionada = undefined
                $scope.construcao = undefined
                $scope.orcamento = []
            }
        })
    }

    $scope.loadComboImport = () => {
        $scope.listaColunaPlanilha = [
            {Id: 'A', Descricao: 'A'},
            {Id: 'B', Descricao: 'B'},
            {Id: 'C', Descricao: 'C'},
            {Id: 'D', Descricao: 'D'},
            {Id: 'E', Descricao: 'E'},
            {Id: 'F', Descricao: 'F'},
            {Id: 'G', Descricao: 'G'},
            {Id: 'H', Descricao: 'H'},
        ];

        $scope.ColOrdem = {Id: 'A', Descricao: 'A'};
        $scope.ColCodigo = {Id: 'B', Descricao: 'B'};
        $scope.ColDescricao = {Id: 'C', Descricao: 'C'};
        $scope.ColUnidade = {Id: 'D', Descricao: 'D'};
        $scope.ColQuantidade = {Id: 'E', Descricao: 'E'};
        $scope.ColPreco = {Id: 'F', Descricao: 'F'};
        $scope.ColPrecoMDO = {Id: 'F', Descricao: 'F'};
        $scope.ColPrecoMaterial = {Id: 'G', Descricao: 'G'};

        $scope.TipoPlanilha = {
            ORCAMENTO: 1,
            ORCAMDOMAT: 2,
            ORCABASE: 3,
            COMPOSICAO: 4
        }
        
        $scope.IdBaseOrigem = '0';
        $scope.listaTipoPlanilha = [
            {Id: $scope.TipoPlanilha.ORCAMENTO, Descricao: 'Orçamento'},
            {Id: $scope.TipoPlanilha.ORCAMDOMAT, Descricao: 'Orçamento Mão de Obra e Material'},
            {Id: $scope.TipoPlanilha.ORCABASE, Descricao: 'Orçamento Conectado na Base'},
            {Id: $scope.TipoPlanilha.COMPOSICAO, Descricao: 'Composições'},
        ];
        $scope.TipoPlanilhaSelecionada = {Id: 1};

        $scope.listaLinhaInicial = [
            {Id: 1, Descricao: 1},
            {Id: 2, Descricao: 2},
            {Id: 3, Descricao: 3},
            {Id: 4, Descricao: 4},
            {Id: 5, Descricao: 5},
            {Id: 6, Descricao: 6},
            {Id: 7, Descricao: 7},
            {Id: 8, Descricao: 8},
            {Id: 9, Descricao: 9},
            {Id: 10, Descricao: 10},
        ];
        $scope.LinhaInicialSelecionada = {Id: 1};

        $scope.titlesPlanilha = {
            TipoPlanilha: 'Tipo de planilha que será importada',
            Linha: 'Número da linha que se encontra a primeira Etapa ou Composição na planilha',
            TipoInsumo: 'Coluna que informa o Tipo do Insumo: Material, Equipamento, Mão-de-obra, Serviço, Taxa e Composição',
            Ordem: 'Coluna que informa a Ordem das Etapas ou Composições',
            Codigo: 'Coluna que informa o Código das Composições ou Insumos',
            Nome: 'Coluna que informa o Nome das Etapas, Composições ou Insumos',
            Unidade: 'Coluna que informa a Unidade das Composições ou Insumos',
            Quantidade: 'Coluna que informa a Quantidade das Composições ou Insumos',
            Preco: 'Coluna que informa o Preço Unitário das Composições ou Insumos',
            PrecoMDO: 'Coluna que informa o Preço Unitário da Mão-de-obra das Composições',
            PrecoMAT: 'Coluna que informa o Preço Unitário do Material das Composições',
            TipoMAT: 'Marcador para "Material"',
            TipoMDO: 'Marcador para "Mão-de-obra"',
            TipoEQU: 'Marcador para "Equipamento"',
            TipoSER: 'Marcador para "Serviço"',
            TipoTAX: 'Marcador para "Taxa"',
            TipoCOM: 'Marcador para "Composição"',
        };

        $scope.helpImport = [
            {
                Id: $scope.TipoPlanilha.ORCAMENTO, 
                linkVideo:'https://vigha.tawk.help/article/importacao-de-planilha-simples', 
                linkFile:'https://www.vighapp.com/planilhamodelo/MODELO_OrcamentoSimples.xlsx', 
                linkBlog:'https://blog.vighapp.com/como-importar-um-orcamento-do-excel-no-vigha/'
            },
            {
                Id: $scope.TipoPlanilha.ORCAMDOMAT, 
                linkVideo:'https://vigha.tawk.help/article/importacao-de-planilha-materia-prima-e-mao-de-obra', 
                linkFile:'https://www.vighapp.com/planilhamodelo/MODELO_OrcamentoMaterialMaoDeObra.xlsx', 
                linkBlog:'https://blog.vighapp.com/como-importar-um-orcamento-do-excel-no-vigha/'
            },
            {
                Id: $scope.TipoPlanilha.ORCABASE,
                linkVideo:'https://vigha.tawk.help/article/importacao-de-planilha-conectada-a-base-publica',
                linkVideo2: 'https://vigha.tawk.help/article/importacao-de-planilha-conectada-a-composicao-propria',
                linkFile:'https://www.vighapp.com/planilhamodelo/MODELO_OrcamentoSINAPI.xlsx', 
                linkFile2:'https://www.vighapp.com/planilhamodelo/MODELO_OrcamentoConectadoBasePropria.xlsx',
                linkBlog:'https://blog.vighapp.com/como-importar-um-orcamento-do-excel-no-vigha/'
            },
            {
                Id: $scope.TipoPlanilha.COMPOSICAO,
                linkVideo:'https://vigha.tawk.help/article/importacao-da-planilha-de-composicao-de-base-propria', 
                linkFile:'https://www.vighapp.com/planilhamodelo/MODELO_Composicoes_OrçamentoConectadoBasePropria.xlsx', 
                linkBlog:'https://blog.vighapp.com/como-importar-um-orcamento-do-excel-no-vigha/'
            }
        ];
    }

    $scope.blocoDePlanilhas = () => {
        if ($scope.sessao.TipoPlano == 3) {
            CacheApp.msgBoxAcessoPremium();
            return;
        }

        $scope.loadComboImport()

        $scope.exibirDropZone = true;
        $scope.listaXLS = [];
        // $scope.getOrigemBase();
        document.querySelectorAll(".drop-zone__input").forEach((inputElement) => {
            const dropZoneElement = inputElement.closest(".drop-zone");

            dropZoneElement.addEventListener("click", (e) => {
                inputElement.click();
            });

            inputElement.addEventListener("change", (e) => {
                if (inputElement.files.length) {
                    const totImagens = inputElement.files.length;
                    var files = inputElement.files;
                    for (var i = 0; i<totImagens; i++){
                        if ($scope.listaXLS.some(c => c.file == files[i]) || files[i].name.indexOf('.xls') < 0)
                            continue;

                        $scope.listaXLS.push({
                            IdCliente: $scope.sessao.ContaAdmin ? $scope.sessao.IdClienteAdmin : $scope.sessao.IdCliente,
                            Nome: files[i].name, 
                            file: files[i]
                        });
                    }
                    $scope.saveList = true;
                    $scope.$apply();
                }
            });

            dropZoneElement.addEventListener("dragover", (e) => {
                e.preventDefault();
                dropZoneElement.classList.add("drop-zone--over");
            });

            ["dragleave", "dragend"].forEach((type) => {
                dropZoneElement.addEventListener(type, (e) => {
                    dropZoneElement.classList.remove("drop-zone--over");
                });
            });

            dropZoneElement.addEventListener("drop", (e) => {
                e.preventDefault();

                if (e.dataTransfer.files.length) {
                    var files = e.dataTransfer.files;
                    const totImagens = files.length;
                    for (var i = 0; i<totImagens; i++){
                        if ($scope.listaXLS.some(c => c.file == files[i]) || files[i].name.indexOf('.xls') < 0)
                            continue;
                        
                        $scope.listaXLS.push({
                            IdCliente: $scope.sessao.ContaAdmin ? $scope.sessao.IdClienteAdmin : $scope.sessao.IdCliente,
                            Nome: files[i].name, 
                            file: files[i]
                        });
                    }

                    if ($scope.listaXLS.length > 0) {
                        $scope.saveList = true;
                        $scope.$apply();
                    }
                }

                dropZoneElement.classList.remove("drop-zone--over");
            });
        }); 
    }

    $scope.salvarListaXLS = () => {

        function salvaXls(xlsFile, config, callBackFunction) {
            xlsFile.progress = 0;
            UploadApp.UploadPlanilhaOrcamento(xlsFile, config,
                function (progress) {
                    xlsFile.progress = progress;
                },
                function (result) {
                    xlsFile.Enviado = true;
                    xlsFile.Sucesso = result.Code == 0;
                    xlsFile.Mensagem = result.Description;
                    callBackFunction(result);
                },
                function (error) { 
                }
            );
        }

        function salvaXlsRecursivo(idx,params,callBack) {
            if (params.lista.length == idx)
                callBack(params.lista)
            else {
                salvaXls(params.lista[idx], params.config, () => {
                    salvaXlsRecursivo(idx+1,params,
                        (data)=>{
                            callBack(data);
                        }
                    );
                });
            }
        }

        var params = {
            lista: $scope.listaXLS,
            config: {
                TipoPlanilha: $scope.TipoPlanilhaSelecionada.Id,
                LinhaInicio: $scope.LinhaInicialSelecionada.Id,
                Coluna: {
                    Ordem: $scope.ColOrdem.Id,
                    Codigo: $scope.ColCodigo.Id,
                    Descricao: $scope.ColDescricao.Id,
                    Unidade: $scope.ColUnidade.Id,
                    Quantidade: $scope.ColQuantidade.Id,
                    Preco: $scope.ColPreco.Id,
                    PrecoMDO: $scope.ColPrecoMDO.Id,
                    PrecoMaterial: $scope.ColPrecoMaterial.Id,
                }
            }
        }

        if ($scope.TipoPlanilhaSelecionada.Id == $scope.TipoPlanilha.ORCABASE) {
            params.config.IdOrigem = $scope.IdBaseOrigem;
            var base = $scope.listaComposicaoDisponivel.filter(l => l.Id == $scope.IdOrigem)[0];
            params.config.UF = params.config.IdOrigem == 0 ? base.Id : base.UF;
            params.config.Periodo = params.config.IdOrigem == 0 ? '000000' : base.Periodo;
        }

        if ($scope.TipoPlanilhaSelecionada.Id == $scope.TipoPlanilha.COMPOSICAO) {
            params.config.TiposInsumos = {
                Composicao: $scope.TiposInsumos.Composicao,
                Material: $scope.TiposInsumos.Material,
                Equipamento: $scope.TiposInsumos.Equipamento,
                MaoDeObra: $scope.TiposInsumos.MaoDeObra,
                Servico: $scope.TiposInsumos.Servico,
                Taxa: $scope.TiposInsumos.Taxa,
            }
        }

        salvaXlsRecursivo(0,params,(data) => {
            $scope.saveList = false
            $scope.refreshObra = true
            $scope.refreshCargaArquivo = true
            $scope.loadObra()
        })
    }

    $scope.abreLink = (tipo, opcao) => {
        var help = $scope.helpImport.filter(h => h.Id == opcao.Id)[0];
        var link = '';
        switch (tipo) {
            case 'video1':
                link = help.linkVideo;
                break;
            case 'video2':
                link = help.linkVideo2;
                break;
            case 'file1':
                link = help.linkFile;
                break;
            case 'file2':
                link = help.linkFile2;
                break;
            default:
                link = help.linkBlog;
                break;
        }

        window.open(link,'_blank')
    }

    $scope.AcessoAndroid($routeParams, (sim) => {
        $scope.AcessoMobile = sim
        $scope.sessao = CacheApp.getSessao()

        // $scope.listaRelatorio = [
        $scope.reportList = [
            { Id: 0, Descricao: 'Curva ABC de Serviços', Permissao: 'GET_CURVAABC', Url: 'curvaabc' },
            { Id: 1, Descricao: 'Curva ABC de Insumos', Permissao: 'GET_RELATCURVAABCMEDICAO', Url: 'curvaabcmedicaoitem' },
            { Id: 2, Descricao: 'Orçamento Analítico de Custo', Permissao: 'GET_ORCAMENTOANALITICO', Url: 'orcamentoanalitico' },
            { Id: 3, Descricao: 'Orçamento Sintético de Custo', Permissao: 'GET_ORCAMENTOANALITICO', Url: 'orcamentosintetico' },
            { Id: 4, Descricao: 'Orçamento Analítico com BDI e Encargos Sociais', Permissao: 'GET_ORCAMENTOBDI', Url: 'orcamentobdiexplicito' },
            { Id: 5, Descricao: 'Orçamento Sintético com BDI e Encargos Sociais', Permissao: 'GET_ORCAMENTOBDI', Url: 'orcamentobdiexplicitosintetico' },
            { Id: 6, Descricao: 'Orçamento Analítico para Proposta', Permissao: 'GET_ORCAMENTOPROPOSTA', Url: 'orcamentobdicliente' },
            { Id: 7, Descricao: 'Orçamento Sintético para Proposta', Permissao: 'GET_ORCAMENTOPROPOSTA', Url: 'orcamentobdiclientesintetico' },
            { Id: 8, Descricao: 'Orçamento Analítico Para Proposta (MDO x MAT)', Permissao: 'GET_ORCAMENTOANALITICO', Url: 'orcamentoanaliticomatxmdo' },
            { Id: 9, Descricao: 'Orçamento Analítico Para Licitação', Permissao: 'GET_ORCAMENTOANALITICO', Url: 'orcamentoanaliticolicitacao' },
            { Id: 10, Descricao: 'Composição de Preços Unitários', Permissao: 'GET_RELATCOMPOSICAO', Url: 'relatoriocomposicao' },
            
        ]

        $scope.refreshCargaArquivo = true
        $scope.loadObra()

        // if ($routeParams.from == 'geral') {
        //     $scope.loadObra()
        // } else {
        //     $scope.construcao = CacheApp.getConstrucao()
        //     $scope.listaRelatorio = $scope.reportList
        //     $scope.getEtapasConstrucao()
        //     $scope.getComposicoes(() => {})
    
        //     $scope.getOrigemBase()
        //     $scope.getListaUnidades()
        //     $scope.getTipoMaterial()
        // }

    });

  }]);
